<?php // Include only
if (!defined ('BOOT')) exit ('No bootstrap.  Exiting.');

/*
Wacintaki Poteto User Authorization Script Copyright 2005-2010 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.4.3x - Last modified 1/4/2010

Requires:
	Preset $OekakiU and $OekakiPass if they are not cookies

Control variables:
	$no_template, $no_online, $quiet_mode

Note:  Do not print anything in $quiet_mode unless it's a security problem, or else applets will freak out.  Just flush everything or use w_log().
*/


// Control variables
{
	// TRUE to avoid including/building template
	if (!isset ($no_template))
		$no_template = FALSE;

	// TRUE to disable online check
	if (!isset ($no_online))
		$no_online = FALSE;

	// TRUE to disable output (satisfies paint applets)
	if (!isset ($quiet_mode))
		$quiet_mode = FALSE;
}


// HTML DOCTYPE and HEAD reference
// Defined here (and not common.php), so test changes are tied to version number
function send_html_headers($override = '') {
	global $charset, $metatag_language;

	if (!empty ($charset)) {
		header ("Content-Type: text/html; charset={$charset}");
	}
	if (!empty ($metatag_language)) {
		header ("Content-Language: {$metatag_language}");
	}

	if ($override == 'html') {
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<?php
	} else {
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<?php
	}
}


// ===================================================================
// Includes
//
$debug         = FALSE;
$wactest       = FALSE;
$version       = '1.4.3';  // Format: M.m.r
$mod_version   = 'wac';    // Type your mod name here
$cfg_ver_check = '1.3.0';  // Config version required
$cfg_db_check  = '1.4.3'; // DB version required

// Autoglobal clean
$usrflags = NULL;
$row      = array();
$cookie_path   = '';
$cookie_domain = '';
$header_extra_metatags = ''; // Mostly for applet <script> tags
$mb_blink_o = '';
$mb_blink_c = '';
$vp_blink_o = '';
$vp_blink_c = '';

// Get config files
if (!@include ('dbconn.php')) {
	if (!file_exists ('dbconn.php')) {
		exit("<html>\n<body>\n<p>Click here to <a href=\"install.php\">run the installer</a>.</p>\n</body>\n</html>");
	} else {
		exit('Cannot open database file!');
	}
}
// Check db version
$result = mysql_query ("SELECT miscstring FROM {$OekakiPoteto_Prefix}oekakimisc WHERE miscname='dbversion'");
$db_temp = mysql_result ($result, 0);
if ($db_temp != $cfg_db_check) {
	mysql_close($dbconn);
	exit ("<html>\n<body>\n<p>Please run the <a href=\"update.php\">updater</a>.</p>\n<p>Database required: v{$cfg_db_check}<br />Config present: v{$db_temp}</p>\n</body>\n</html>");
}
unset ($dbtemp);

// Remap prefixes
$db_op  = $OekakiPoteto_Prefix; // Deprecated
$db_pre = $OekakiPoteto_Prefix;
$db_mem = $OekakiPoteto_MemberPrefix;


$cfg = array();
if (!@include ('config.php')) {
	mysql_close($dbconn);
	exit('Cannot open config file!');
} else {
	// Check version
	if ($cfg['version'] != $cfg_ver_check) {
		mysql_close($dbconn);
		exit("<html>\n<body>\n<p>Please run the <a href=\"update.php\">updater</a>.</p>\n<p>Config required: v{$cfg_ver_check}<br />Config present: v{$cfg['version']}</p>\n</body>\n</html>");
	}
}


// ===================================================================
// Hacks! (requires config, call before startup/common.php)
// Included here since boot.php is used on EVERY page, and hacks may be security/user related
//
if (file_exists ($cfg['res_path'].'/'.'hacks.php')) {
	define ('HACK_CHECK', 1); // Version control
	include ($cfg['res_path'].'/'.'hacks.php');
}

// Easy fix
if (!defined ('MIN_AGE_ADULT')) {
	define ('MIN_AGE_ADULT', 18);
}

// Lightbox/Litebox/Lytebox/Slimbox
$pic_viewer_norm  = 'rel="lytebox[norm]"';
$pic_viewer_adult = 'rel="lytebox[adult]"';


// ===================================================================
// Startup
//

// E_ALL still needs some more testing
// Missing hacks.php can cause issues
if (isset ($wactest) && $wactest) {
	error_reporting (E_ALL);
} else {
	error_reporting (E_ALL ^ E_NOTICE);
}

// Critical functions
require ('common.php');

// ===================================================================
// GPC
//

// Main
$mode   = w_gpc('mode', 'a');
$action = w_gpc('action', 'a');
$pageno = w_gpc('pageno', 'i+');
$sort   = w_gpc('sort', 'i+');
$artist = w_gpc('artist');
$a_match = w_gpc('a_match');


// Login validation
// If not set elsewhere (ex: by applets), we import cookies here
if (!isset ($OekakiU) && !isset ($OekakiPass)) {
	$OekakiU    = '';
	$OekakiPass = '';
	if (isset ($_COOKIE['OekakiU']) && isset ($_COOKIE['OekakiPass'])) {
		$OekakiU    = $_COOKIE['OekakiU'];
		$OekakiPass = $_COOKIE['OekakiPass'];
	}
}
$OekakiU    = addslashes (str_replace ('\\', '', $OekakiU));
$OekakiPass = addslashes (str_replace ('\\', '', $OekakiPass));


// ===================================================================
// Init
//

// Benchmark
$start_time = get_microtime();

// Cookies
$cookie_life = 2419200; // in seconds

// User info
$user  = array(); // SQL user data
$user['no_viewer'] = 0; // Another hack

$flags = array(); // Permission flags
$flags['all']    = $usrflags;
$flags['member'] = 0; // Is a registered member
$flags['G']      = 0; // Is a registered member (old flag)
$flags['mod']    = 0; // Is a moderator
$flags['admin']  = 0; // Is an admin
$flags['sadmin'] = 0; // Is a super admin
$flags['owner']  = 0; // Is owner
$flags['rank']   = 0; // (0-9)
$flags['D']      = 0; // Draw access
$flags['M']      = 0; // Anim access
$flags['I']      = 0; // Immunity
$flags['U']      = 0; // Upload access
$flags['X']      = 0; // Adult access

// Admin rank numbers
define ('RANK_MOD',    4);
define ('RANK_ADMIN',  5);
define ('RANK_SADMIN', 7);
define ('RANK_OWNER',  9);

// Import init (needs config, hacks)
$language = $cfg['language'];
$template = $cfg['template'];
$cssinclude    = ''; // Path for HTML style tag
$template_name = '';

// Picture and thumbnail logic
$p_pic = $cfg['op_pics'].'/'.$cfg['op_pre'];
$t_pic = $cfg['op_pics'].'/'.$cfg['op_pre'].'t';
$r_pic = $cfg['op_pics'].'/'.$cfg['op_pre'].'r';
$p_prefix = $cfg['op_pre'];
$t_prefix = $cfg['op_pre'].'t';
$r_prefix = $cfg['op_pre'].'r';

// Mailbox
$mail_status = array();
$mail_status['new']     = 0;
$mail_status['unread']  = 1;
$mail_status['read']    = 2;
$mail_status['replied'] = 3;

// Dates
$datef = array();
$datef['post_header'] = 'l, F jS Y, g:i A';
$datef['admin_edit']  = 'F j, Y, g:i a';
$datef['chat']        = 'H:i';
$datef['birthdate']  = 'Y/n/j';
$datef['birthmonth'] = 'Y/n';
$datef['birthyear']  = 'Y';

// Fun
$stupid_name  = '';
$stupid_guest = '';

// Avoid really nasty DomainStat.net worm (infects whole servers)
if (!defined ('domainstat')) {
	define ('domainstat', 'ok');
}


// ===================================================================
// Process Registration
//
if (!empty ($OekakiU) && !empty ($OekakiPass)) {
	$result = mysql_query ("SELECT * FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$OekakiU'");
	if ($result) {
		if (mysql_num_rows ($result)) {
			$user = @mysql_fetch_array ($result);

			// Verify password
			if ($OekakiPass == $user['usrpass']) {
				// Verify active (non-pending)
				if (strstr ($user['usrflags'], 'G') && !strstr ($user['usrflags'], 'P')) {
					// Note: pending members should not have cookies!
					$user['member'] = 1;
				}
			}
		}
	} else {
		// It's serious to have SQL bomb here
		w_log_sql('boot:'.__LINE__);

		if (!$quiet_mode) {
			// Not quiet mode?  DIE!
			w_exit ('Login failed due to a server error.  If the problem persists, ask the admin to check the oekaki log.');
		}

		// Flush for quiet mode
		$user = array();
		$flags = array();
	}


	// If SQL works and registration checks out
	if ($user['member']) {
		// Get flags ($usrflags, $rank)
		$flags = parse_flags ($user['usrflags'], $user['rank']);

		//
		// Get language, template
		// Blank for either means use default
		//
		if (!empty ($user['language'])) {
			$language = $user['language'];
		}
		if (!empty ($user['templatesel'])) {
			$template = $user['templatesel'];
		}

		//
		// Update last login
		//
		$result = @mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET lastlogin=NOW() WHERE usrname='$OekakiU'");

	} else {
		// Password didn't match up!  Clear user info
		$OekakiU = '';
		$OekakiPass = '';
		$user = array();
		$flags = array();

		if (!$quiet_mode) {
			if ($debug) {
				echo 'Cookie Reset';
			} else {
				w_unset_cookie ('OekakiU');
				w_unset_cookie ('OekakiPass');
			}
		}

		// Note: don't redirect here, or an infinate loop may result.
	}
}


// ===================================================================
// Ban list
// BAN_OVERRIDE is for hacks, BAN_KILL is internal use only
//
// Get IP and hostname
$address  = 'invalid';
$hostname = 'invalid';
if (!empty ($_SERVER['REMOTE_ADDR'])) {
	$address = $_SERVER['REMOTE_ADDR'];
	if (! (defined ('DISABLE_DNS_HOST_LOOKUP') && DISABLE_DNS_HOST_LOOKUP)) {
		$hostname = @gethostbyaddr ($address);
	}
}

if (! (defined ('BAN_OVERRIDE') && BAN_OVERRIDE)) {
	if (! (defined ('BAN_KILL') && BAN_KILL)) {
		// !hacks.php
		require ('banscript.php');
	}
}

// Track IP after loading ban list
if (!empty ($OekakiU) && !empty ($OekakiPass)) {
	$result = @mysql_query ("UPDATE `{$OekakiPoteto_MemberPrefix}oekaki` SET `IP`='{$address}' WHERE `usrname`='$OekakiU'");
}


// ===================================================================
// If registered or non-registered
//

// Needed in quiet mode for error reporting
include ('language/'.$language.'.php');

// Check for quiet mode.
if (!$quiet_mode) {

	// Import niftytoo
	require ('niftytoo.php');

	// Build and set template
	//
	$template_name = $template;
	$template_file = $cfg['tpl_path'].'/'.$template;
	$cssinclude = $template_file.'.css';

	if (!$no_template) {
		// If regular member, use built CSS
		// If admin, compare template w/CSS and rebuild if needed

		$my_css_exists = FALSE;
		$my_template_build = FALSE;

		if (file_exists ($template_file.'.css')) {
			$my_css_exists = TRUE;
		}

		if ($my_css_exists) {
			if ($flags['admin']) {
				if (file_exists ($template_file.'.php')) {
					if (filemtime ($template_file.'.php') > filemtime ($template_file.'.css')) {
						// Template is newer!  Rebuild CSS.
						$my_template_build = TRUE;
					}
				}
			}
		} else {
			// No CSS.  New template?
			$my_template_build = TRUE;
		}

		if ($my_template_build) {
			if (file_exists ($template_file.'.php')) {
				if (!is_writable ($cfg['tpl_path'])) {
					w_exit ('Templates folder is locked!  Folder must be CHMOD to 755 (preferred) or 777.  View Readme.txt for help.');
				}

				// Build CSS
				$tcontrol = 'build';
				ob_start();
				include ($template_file.'.php');
				$cssdata = ob_get_contents();
				if (!empty ($cssdata) && $handle = @fopen ($template_file.'.css', 'w')) {
					fwrite ($handle, $cssdata);
					fclose ($handle);
				} else {
					// CSS problem! Use default
					$cssinclude = $cfg['tpl_path'].'/'.$template.'.css';
					$template_name = $template;

					if (!file_exists($cssinclude)) {
						// Mega problem!
						$cssinclude = $cfg['tpl_path'].'/Default.css';
						$template_name = 'Failsafe';
					}
				}
				ob_clean();
				unset ($tcontrol);
			} else {
				/*
				Let's hope that a broken template returns a 404, so admins will
				look for what's wrong.  Don't throw w_exit(), so admins can still
				actually moderate if the template is b0rked!
				*/
			}
		}
	} // End template build


	// Set layout, thumbnail
	if ($flags['member']) {
		$display = $user['picview'];
		$screensize = 800;
		if ($user['screensize'] > 0) {
			$screensize = $user['screensize'];
		}

		if ($cfg['force_thumb'] == 'yes' || $user['thumbview'] == 0) {
			$thumbDisplay = $cfg['use_thumb'];
		} else {
			$thumbDisplay = $user['thumbview'];
		}

		// Account "Screenshot" disables thumbnails
		if (strtolower ($OekakiU) == 'screenshot') {
			$thumbDisplay = 0;
		}
	} else {
		$display = 0;
		$screensize = 800;
		$thumbDisplay = $cfg['use_thumb'];
	}


	// Check installer, updater.  For effiency and to resolve conflicts
	// with non-installed boards, check for admin cookies only.
	if ($action == 'secure') {
		$my_fail = 0;
		if (file_exists('install.php')) {
			if (@unlink('install.php')) {
				echo ("Installer removed<br />\n");
			} else {
				echo ("Installer removal failed!<br />\n");
				$my_fail++;
			}
		}
		if (file_exists('update.php')) {
			if (@unlink ('update.php')) {
				echo ("Updater removed<br />\n");
			} else {
				echo ("Updater removal failed!<br />\n");
				$my_fail++;
			}
		}
		if ($my_fail) {
			w_exit("<p>Remove the files manually via FTP</p>");
		} else {
			w_exit("<p><a href=\"index.php\">Proceed to index page</a></p>");
		}
	}
	if ($flags['admin']) {
		if (file_exists ('install.php') || file_exists ('update.php')) {
			w_exit("<html>\n<body>\n<p>&ldquo;install.php&rdquo; and/or &ldquo;update.php&rdquo; still exists!</p>\nIf you do not need them anymore, <a href=\"index.php?action=secure\">click here to remove them</a>.</p>\n<p>If you get this error again, delete the files manually via FTP.</p>\n</body>\n</html>");
		}
	}


	// ===================================================================
	// Online
	//
	if (!$no_online) {
		if (!empty ($_SERVER['PHP_SELF'])) {
			// Fixes servers using PHP as a runtime and not as a module
			$my_script = $_SERVER['PHP_SELF'];
		} else {
			$my_script = $SCRIPT_NAME;
		}

		// Due to popular demand, locations are back.
		// Useful for debugging, too, so almost all scripts are included
		if (empty ($my_script)) {
			$my_script = 'Unknown';
		} else {
			$loc_list = array (
				'index'=>'View',
				'chat'=>'Chat',
				'addusr'=>'Adding User',
				'banlist'=>'Banlist',
				'chibipaint'=>'Chibi Paint',
				'chngpass'=>'Changing Password',
				'comment.'=>'Commenting',
				'cpanel'=>'Control Panel',
				'delcomments.'=>'Delete Comments',
				'delpics.'=>'Delete Picture',
				'delusr'=>'Delete Users',
				'draw'=>'Draw Screen',
				'edit_avatar'=>'Edit Avatar',
				'editcomm'=>'Edit Comment',
				'editnotice'=>'Edit Notice/Banner',
				'editpic'=>'Edit Picture',
				'editprofile'=>'Edit Profile',
				'editrules'=>'Edit Rules',
				'faq'=>'FAQ',
				'lcommentdel'=>'Delete Comment',
				'lostpass'=>'Password Recovery',
				'mail'=>'Mailbox',
				'massmail'=>'Mass Mailbox',
				'memberlist'=>'Memberlist',
				'modflags'=>'Member Permissions',
				'newpass'=>'Change Password',
				'noteBBS'=>'NoteBBS',
				'oekakiBBS'=>'OekakiBBS',
				'paintBBS'=>'PaintBBS',
				'profile'=>'Profile Viewer',
				'recover'=>'Picture Recovery',
				'register'=>'Registration',
				'retouch'=>'Retouch',
				'shiBBS'=>'ShiPainter',
				'showrules'=>'Rules',
				'testinfo'=>'Diagnostics',
				'upload'=>'Upload',
				'viewani'=>'Anim Viewer',
				'whosonline'=>'Online'
			);

			$loc = 'View';
			foreach ($loc_list as $loc_key=>$loc_val) {
				if (strpos ($my_script, $loc_key) !== FALSE) {
					$loc = $loc_val;
					break;
				}
			}
		}

		// Maintenance
		if ($loc != 'Chat' && $loc != 'Online') {
			$online = mysql_query ('DELETE FROM '.$OekakiPoteto_MemberPrefix.'oekakionline WHERE (DATE_ADD(onlinetime, INTERVAL 15 MINUTE) < NOW())');

			$online = mysql_query ('DELETE FROM '.$OekakiPoteto_MemberPrefix.'oekakionline WHERE (DATE_ADD(onlinetime, INTERVAL 1 MINUTE) < NOW()) AND locale=\'Chat\'');
		}

		if ($flags['member'] && !empty ($OekakiU) && $loc != 'Online') {
			// User is on OekakiPoteto; check if present on table
			$online = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekakionline SET onlinetime=NOW(), locale='{$loc}', onlineboard='".addslashes ($cfg['op_title'])."' WHERE onlineusr='{$OekakiU}'");

			if (!mysql_affected_rows()) {
				$online = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakionline SET onlineusr='{$OekakiU}', onlinetime=NOW(), onlineIP='{$address}', locale='{$loc}', onlineboard='".addslashes ($cfg['op_title'])."'");
			}
		}
	} // End Online

} // End quiet mode

?>