<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2009 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.4.3 - Last modified 9/7/2009
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');


if (!$flags['owner']) {
	report_err($langop_noaccesscp);
}


// User submits information
if (isset ($_POST['action'])) {
	// Verify new picstore value
	if (w_gpc('pic_store', 'i') < $cfg['pic_store']) {
		if (w_gpc('pic_store_confirm') != 'confirm') {
			report_err($langop_pic_store_change_confirm);
		}
	}

	// Get rid of trailing slashes
	$bbs_url         = strip_path(w_gpc('op_url'));
	$bbs_preview_img = strip_path(w_gpc('preview_img'));
	$bbs_pr0n_img    = strip_path(w_gpc('xxx_img'));
	$avatar_folder   = strip_path(w_gpc('avatar_folder'));

	// Fix email
	$bbs_email = trim (w_gpc('op_email'));

	// Fix HTML entries, like the BBS title.
	$bbs_title  = w_gpc('op_title', 'html');
	$bbs_author = w_gpc('op_author', 'html');
	$bbs_preview_title = w_gpc('preview_title', 'html');

	// Other verification
	$bbs_language = w_gpc('language');
	$bbs_template = w_gpc('template');

	$reg_draw   = 'no';
	$reg_anim   = 'no';
	$reg_upload = 'no';
	if (w_gpc('reg_draw')   == 'D') $reg_draw = 'yes';
	if (w_gpc('reg_anim')   == 'A') $reg_anim = 'yes';
	if (w_gpc('reg_upload') == 'U') $reg_upload = 'yes';

	// Verify min/max values
	{
		$verify     = array ('pic_store', 'pic_pages', 'menu_pages', 'def_x', 'def_y', 'canvas_x', 'canvas_y', 'min_x', 'min_y', 'canvas_a', 'max_anim', 'thumb_bytes', 'thumb_t', 'thumb_r', 'max_pic', 'avatar_x', 'avatar_y', 'safety_storetime');
		$verify_min = array (50,           1,           5,            50,      50,      50,         50,         50,      50,      2500,       1000,       25000,         50,        50,        100000,    5,          5,          1);
		$verify_max = array (500000,       50,          500,          10000,   10000,   10000,      10000,      10000,   10000,   100000000,  5000000,    15000000,      500,       1000,      15000000,  150,        150,        10000);

		for ($i = 0; $i < count ($verify); $i++) {
			if ($_POST[$verify[$i]] < $verify_min[$i]) $_POST[$verify[$i]] = $verify_min[$i];
			if ($_POST[$verify[$i]] > $verify_max[$i]) $_POST[$verify[$i]] = $verify_max[$i];
		}
	}


	// Create a configuration file with specified settings
	$main_configuration = <<<EOF
<?php // Include only
	\$cfg = array();
	\$cfg['version'] = '1.3.0';

	\$cfg['op_title']  = '{$bbs_title}';
	\$cfg['op_author'] = '{$bbs_author}';
	\$cfg['op_adult']  = '{$_POST['op_adult']}';
	\$cfg['op_email']  = '{$bbs_email}';
	\$cfg['op_url']    = '{$bbs_url}';

	\$cfg['salt']    = '{$cfg['salt']}';
	\$cfg['op_pics'] = '{$cfg['op_pics']}';
	\$cfg['op_pre']  = '{$cfg['op_pre']}';

	\$cfg['kill_user']     = '{$_POST['kill_user']}';
	\$cfg['kill_reg']      = '15';
	\$cfg['draw_immune']   = '{$_POST['draw_immune']}';
	\$cfg['approval']      = '{$_POST['approval']}';
	\$cfg['require_art']   = '{$_POST['require_art']}';
	\$cfg['guest_post']    = '{$_POST['guest_post']}';
	\$cfg['guest_draw']    = 'no'; //WIP
	\$cfg['guest_adult']   = '{$_POST['guest_adult']}';
	\$cfg['humanity_post'] = '{$_POST['humanity_post']}';
	\$cfg['reg_draw']      = '$reg_draw';
	\$cfg['reg_anim']      = '$reg_anim';
	\$cfg['reg_upload']    = '$reg_upload';
	\$cfg['reg_rules']     = '{$_POST['reg_rules']}';

	\$cfg['language'] = '{$bbs_language}';
	\$cfg['template'] = '{$bbs_template}';
	\$cfg['tpl_path'] = '{$cfg['tpl_path']}';
	\$cfg['res_path'] = '{$cfg['res_path']}';

	\$cfg['pic_store']  = '{$_POST['pic_store']}';
	\$cfg['pic_pages']  = '{$_POST['pic_pages']}';
	\$cfg['menu_pages'] = '{$_POST['menu_pages']}';
	\$cfg['pic_limit']      = '2';  //WIP
	\$cfg['pic_limit_time'] = '24'; //WIP
	\$cfg['use_viewer'] = '{$_POST['use_viewer']}';

	\$cfg['porn_img']      = '{$bbs_pr0n_img}';
	\$cfg['preview_img']   = '{$bbs_preview_img}';
	\$cfg['preview_title'] = '{$bbs_preview_title}';
	\$cfg['def_x']    = '{$_POST['def_x']}';
	\$cfg['def_y']    = '{$_POST['def_y']}';
	\$cfg['canvas_x'] = '{$_POST['canvas_x']}';
	\$cfg['canvas_y'] = '{$_POST['canvas_y']}';
	\$cfg['min_x']    = '{$_POST['min_x']}';
	\$cfg['min_y']    = '{$_POST['min_y']}';
	\$cfg['canvas_a'] = '{$_POST['canvas_a']}';
	\$cfg['max_anim'] = '{$_POST['max_anim']}';
	\$cfg['max_pic']  = '{$_POST['max_pic']}';

	\$cfg['use_thumb']   = '{$_POST['use_thumb']}';
	\$cfg['force_thumb'] = '{$_POST['force_thumb']}';
	\$cfg['thumb_bytes'] = '{$_POST['thumb_bytes']}';
	\$cfg['thumb_t']     = '{$_POST['thumb_t']}';
	\$cfg['thumb_r']     = '{$_POST['thumb_r']}';
	\$cfg['thumb_jpg']   = '75';

	\$cfg['use_mailbox'] = '{$_POST['use_mailbox']}';

	\$cfg['use_chat']   = '{$_POST['use_chat']}';
	\$cfg['chat_max']   = '{$_POST['chat_max']}';
	\$cfg['chat_pages'] = '{$_POST['chat_pages']}';

	\$cfg['smilies'] = '{$_POST['smilies']}';

	\$cfg['use_avatars']   = '{$_POST['use_avatars']}';
	\$cfg['use_c_avatars'] = '{$_POST['use_c_avatars']}';
	\$cfg['avatar_folder'] = '{$avatar_folder}';
	\$cfg['avatar_x'] = '{$_POST['avatar_x']}';
	\$cfg['avatar_y'] = '{$_POST['avatar_y']}';

	\$cfg['public_retouch']   = '{$_POST['public_retouch']}';
	\$cfg['safety_storetime'] = '{$_POST['safety_storetime']}';
	\$cfg['safety_saves']     = '{$_POST['safety_saves']}';
	\$cfg['self_bump']        = '{$_POST['self_bump']}';
?>
EOF;
//<?


	// Write the config files
	if ($fp = fopen ('config.php', 'w')) {
		fwrite ($fp, $main_configuration);
		fclose ($fp);
	} else {
		report_err($langop_cperr3.' '.$cfg_file.' '.$langop_cperr2);
	}

	// Update templates if needed
	if ($_POST['t_reset'] == 'yes') {
		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET templatesel=''");
	}


	// Log cpanel changes
	w_log(WLOG_CPANEL, 'cpanel: updated');


	// Cleanup picture slots
	@set_time_limit(300);
	include_once ('paintsave.php');
	$cfg['pic_store'] = w_gpc('pic_store', 'i+'); // Reset before cleaning
	clean_picture_slots(500);


	// Update thumbnails
	$cfg['thumb_t'] = $_POST['thumb_t'];
	$cfg['thumb_r'] = $_POST['thumb_r'];
	$use_thumb = 1;

	if ($_POST['use_thumb'] == 0) {
		// Remove all thumbs
		$result = mysql_query ("SELECT PIC_ID FROM {$OekakiPoteto_Prefix}oekakidta");
		$num_rows = mysql_num_rows ($result);

		for ($i = 0; $i < $num_rows; $i++) {
			fix_thumbnail(mysql_result ($result, $i), FALSE);
		}
	} elseif ($_POST['use_thumb'] != 0 && $_POST['rebuildThumb'] == 1) {
		// Rebuild all archived pictures
		$result = mysql_query ("SELECT PIC_ID FROM {$OekakiPoteto_Prefix}oekakidta WHERE archive='1'");
		$num_rows = mysql_num_rows ($result);

		for ($i = 0; $i < $num_rows; $i++) {
			fix_thumbnail(mysql_result ($result, $i));
		}
	} elseif ($_POST['use_thumb'] != 0 && $_POST['rebuildThumb'] == 2) {
		// Rebuild all thumbs
		$result = mysql_query ("SELECT PIC_ID FROM {$OekakiPoteto_Prefix}oekakidta");
		$num_rows = mysql_num_rows ($result);

		for ($i = 0; $i < $num_rows; $i++) {
			// Timeout fix
			if ((get_microtime() - $start_time) > 250)
				break;

			fix_thumbnail(mysql_result ($result, $i));
		}
	} elseif ($_POST['use_thumb'] != $cfg['use_thumb'] || $_POST['thumb_t'] != $cfg['thumb_t'] || $_POST['thumb_r'] != $cfg['thumb_r']) {
		// Options changed -- rebuild last {$_POST['pic_pages']} pictures
		$number = w_gpc('pic_pages', 'i');
		$result = mysql_query ("SELECT PIC_ID FROM {$OekakiPoteto_Prefix}oekakidta ORDER BY postdate DESC LIMIT 0, {$number}");
		$num_rows = mysql_num_rows ($result);

		for ($i = 0; $i < $num_rows; $i++) {
			fix_thumbnail(mysql_result ($result, $i));
		}
	}

	all_done();
}


include ('header.php');

?>
<div id="contentmain">
	<form name="form1" method="post" action="cpanel.php">
		<input type="hidden" name="action" value="submit" />

		<h1 class="header">
			<?=$langop_install_dispreg?> 
		</h1>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_opurl?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="op_url" type="text" value="<?=$cfg['op_url']?>" size="40" class="txtinput" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_email?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="op_email" type="text" value="<?=$cfg['op_email']?>" size="40" class="txtinput" />

				<p class="subtext">
					<?=$langop_install_emailsub?> 
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h1 class="header">
			<?=$langop_word_storage?> 
		</h1>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_picstore?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="pic_store" type="text" value="<?=$cfg['pic_store']?>" size="8" class="txtinput" />

				<p class="subtext">
					<input type="checkbox" name="pic_store_confirm" value="confirm" /> <?=$langop_cpanel_check_box_confirm?><br />
					<?=$langop_cpmsg1?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_allowppicture?>
			</td>
			<td class="infoenter" valign="top">
				<select name="public_retouch" class="multiline">
<? if ($cfg['public_retouch'] != 'no') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>
				<p class="subtext">
					<?=$langop_ppmsgrtouch?> 
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_allowsafesave?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="safety_saves" class="multiline">
<? if ($cfg['safety_saves'] != 'no') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>
				<p class="subtext">
					<?=$langop_safesaveexp?> 
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_savestorage?>
			</td>
			<td class="infoenter" valign="top">
				<input name="safety_storetime" type="text" value="<?=$cfg['safety_storetime']?>" size="8" class="txtinput" /> <?=$langop_word_days?>

				<p class="subtext">
					<?=$langop_safetydays?> 
				</p>
			</td>
			</tr>
			</table>

			<input name="op_pre" type="hidden" value="<?=$cfg['op_pre']?>" />
		</div>
		<br />



		<h1 class="header">
			<?=$langop_install_reg?> 
		</h1>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_adel?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="kill_user" type="text" value="<?=$cfg['kill_user']?>" size="5" class="txtinput" />
				<?=$langop_install_adelsub2?> 

				<p class="subtext">
					<?=$langop_install_adelsub?> 
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_autoimune?>
			</td>
			<td class="infoenter" valign="top">
				<select name="draw_immune" class="multiline">
<? if ($cfg['draw_immune'] != 'no') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_autoimune_exp?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_showrulereg?>
			</td>
			<td class="infoenter" valign="top">
				<select name="reg_rules" class="multiline">
<? if ($cfg['reg_rules'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_showruleregexp?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_gallow?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="guest_post" class="multiline">
<? if ($cfg['guest_post'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_install_gallowsub?> 
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Humanity test -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_cpanel_humanity_infoask;?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="humanity_post" class="multiline">
<? if ($cfg['humanity_post'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_cpanel_humanity_sub;?> 
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Require Art -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_requireartsub?>
			</td>
			<td class="infoenter" valign="top">
				<select name="require_art" class="multiline">
<? if ($cfg['require_art'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_requireartsubyes?><br />
					<?=$langop_requireartsubno?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_rapproval?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="approval" class="multiline">
<? if ($cfg['approval'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
					<option value="force"><?=$langop_forceactivate?></option>
<? } elseif ($cfg['approval'] == 'no') { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
					<option value="force"><?=$langop_forceactivate?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
					<option value="force" selected="selected"><?=$langop_forceactivate?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_activateyes?><br />
					<?=$langop_activeno?><br />
					<b><?=$langop_activateforced?></b>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_defaultpermis?>
			</td>
			<td class="infoenter" valign="top">
				<input name="reg_draw" type="checkbox" value="D" <? if ($cfg['reg_draw'] == 'yes') {echo 'checked="checked" ';} ?>/><?=$langop_type_daccess?><br />
				<input name="reg_anim" type="checkbox" value="A" <? if ($cfg['reg_anim'] == 'yes') {echo 'checked="checked" ';} ?>/><?=$langop_type_aaccess?><br />
				<input name="reg_upload" type="checkbox" value="U" <? if ($cfg['reg_upload'] == 'yes') {echo 'checked="checked" ';} ?>/><?=$langop_type_uaccess?>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Self Bump -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_bumpretouch?>
			</td>
			<td class="infoenter" valign="top">
				<select name="self_bump" class="multiline">
<? if ($cfg['self_bump'] != 'no') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h1 class="header">
			<?=$langop_install_dispgen?> 
		</h1>

		<div class="infotable">
			<table class="infomain">


			<!-- BBS Title -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_title2?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="op_title" type="text" value="<?=$cfg['op_title']?>" size="40" class="txtinput" />

				<p class="subtext">
					<?=$langop_install_title2sub?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- BBS Author -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_authorname?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="op_author" type="text" value="<?=$cfg['op_author']?>" size="40" class="txtinput" />

				<p class="subtext">
					<?=$langop_bbsowner?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_adultrbbs?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="op_adult" class="multiline">
<? if ($cfg['op_adult'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>
				<br />

				<p class="subtext">
					<?=$langop_adultrbbsdesc?><br />
					<?=$langop_adultrbbsnote?> 
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_cpanel_use_lightbox;?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="use_viewer" class="multiline">
<? if ($cfg['use_viewer'] == '1') { ?>
					<option value="1" selected="selected"><?=$langop_word_yes?></option>
					<option value="0"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="1"><?=$langop_word_yes?></option>
					<option value="0" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_cpanel_lightbox_sub;?> 
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_allowpron?>
			</td>
			<td class="infoenter" valign="top">
				<select name="guest_adult" class="multiline">
<? if ($cfg['guest_adult'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_allowpronyes?><br />
					<?=$langop_allowpronno?>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Default Language -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_cpanel_deflang?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="language" id="select" class="multiline">
<?
if ($handle = opendir('language')) {
	// This is the correct way to loop over the directory.
	while (false !== ($file = readdir ($handle))) {
		if (substr ($file, -4) == '.php') {
			if (substr ($file, 0, -4) == $cfg['language']) {
?>
					<option value="<?=substr ($file, 0, -4)?>" selected="selected"><?=substr ($file, 0, -4)?></option>
<?
			} else {
?>
					<option value="<?=substr ($file, 0, -4)?>"><?=substr ($file, 0, -4)?></option>
<?
			}
		}
	}
	closedir ($handle);
}
?>
				</select>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Default Template -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_deftem?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="template" class="multiline">
<? if ($handle = opendir ('templates')) {
	/* This is the correct way to loop over the directory. */

	while (false !== ($file = readdir ($handle))) {
		if (substr ($file, -4) == '.php'){
			if (substr ($file, 0, -4) == $cfg['template']) { ?>
					<option value="<?=substr ($file, 0, -4)?>" selected="selected"><?=substr ($file, 0, -4)?></option>
<?
			} else {
?>
					<option value="<?=substr ($file, 0, -4)?>"><?=substr ($file, 0, -4)?></option>
<?
			}
		}
	}
	closedir ($handle);
} ?>
				</select>

				<p class="subtext">
					<?=$langop_install_deftemsub?> 
				</p>
			</td>
			</tr>

			<!-- Reset templates -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_resettemplate?>
			</td>
			<td class="infoenter" valign="top">
				<select name="t_reset" class="multiline">
					<option value="no" selected="selected"><?=$langop_word_no?></option>
					<option value="yes"><?=$langop_word_yes?></option>
				</select>

				<p class="subtext">
					<?=$langop_install_resettemplatesub?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pictures per index page -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_maxpiconind?>
			</td>
			<td class="infoenter" valign="top">
				<input name="pic_pages" type="text" value="<?=$cfg['pic_pages']?>" size="8" class="txtinput" />

				<p class="subtext">
					<?=$langop_maxpicinddesc?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pictures per other page -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_menuentries?>
			</td>
			<td class="infoenter" valign="top">
				<input name="menu_pages" type="text" value="<?=$cfg['menu_pages']?>" size="8" class="txtinput" />

				<p class="subtext">
					<?=$langop_menuentriesdesc?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Smilies -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_usesmilies?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="smilies" class="multiline">
<? if ($cfg['smilies'] != 'no') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>
				<p class="subtext">
					<?=$langop_usesmiliedesc?> 
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Avatars -->
		<h1 class="header">
			<?=$langop_word_avatars?>
		</h1>

		<div class="infotable">
			<table class="infomain">
			<!-- Enable -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_enableavata?>
			</td>
			<td class="infoenter" valign="top">
				<select name="use_avatars" class="multiline">
<? if ($cfg['use_avatars'] != 'no') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_allowavatar?>
			</td>
			<td class="infoenter" valign="top">
				<select name="use_c_avatars" class="multiline">
<? if ($cfg['use_c_avatars'] != 'yes') { ?>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
					<option value="yes"><?=$langop_word_yes?></option>
<? } else { ?>
					<option value="no"><?=$langop_word_no?></option>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
<? } ?>
				</select>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_AvatarStore?>
			</td>
			<td class="infoenter" valign="top">
				<input name="avatar_folder" type="text" class="txtinput" size="60" value="<?=$cfg['avatar_folder'].'/';?>" />

				<p class="subtext">
					<?=$langop_changemulti?><br />
					<?=$langop_cpmsg2?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				<?=$langop_maxavatar?>
			</td>
			<td class="infoenter" valign="top">
				<input name="avatar_x" type="text" value="<?=$cfg['avatar_x']?>" size="6" class="txtinput" />
				&times;
				<input name="avatar_y" type="text" value="<?=$cfg['avatar_y']?>" size="6" class="txtinput" />

				<p class="subtext">
					<?=$langop_maxavatardesc?>
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Applets -->
		<h1 class="header">
			<?=$langop_install_appletset?> 
		</h1>

		<div class="infotable">
			<table class="infomain">
			<!-- Canvas Defaults Width -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_cavasize?>
			</td>
			<td class="infoenter" valign="top">
				<input name="def_x" type="text" value="<?=$cfg['def_x']?>" size="6" class="txtinput" />
				&times;
				<input name="def_y" type="text" value="<?=$cfg['def_y']?>" size="6" class="txtinput" />

				<p class="subtext">
					<?=$langop_defcanvasize?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Canvas Min -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_mincanvasize?>
			</td>
			<td class="infoenter" valign="top">
				<input name="min_x" type="text" value="<?=$cfg['min_x']?>" size="6" class="txtinput" />
				&times;
				<input name="min_y" type="text" value="<?=$cfg['min_y']?>" size="6" class="txtinput" />

				<p class="subtext">
					<?=$langop_mincanvasizedesc?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Canvas Max -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_maxcanvasize?>
			</td>
			<td class="infoenter" valign="top">
				<input name="canvas_x" type="text" value="<?=$cfg['canvas_x']?>" size="6" class="txtinput" />
				&times;
				<input name="canvas_y" type="text" value="<?=$cfg['canvas_y']?>" size="6" class="txtinput" />

				<p class="subtext">
					<?=$langop_maxcanvasizedesc?>.<br />
					<?=$langop_maxcanvasizedesc2?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Anim -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_animax?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="max_anim" type="text" value="<?=$cfg['max_anim']?>" size="40" class="txtinput" />
				<?=$langop_install_bytes?> 

				<p class="subtext">
					<?=$langop_install_animaxsub?> 
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Upload -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_maxfilesize?>
			</td>
			<td class="infoenter" valign="top">
				<input name="max_pic" type="text" value="<?=$cfg['max_pic']?>" size="40" class="txtinput" />
				<?=$langop_install_bytes?> 

				<p class="subtext">
					<?=$langop_maxupfileexp?><br />
					<?=$langop_maxupfileexp2?>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">
				&nbsp;
				<input name="canvas_a" type="hidden" value="<?=$cfg['canvas_a']?>" />
			</td></tr>


			<!-- Max Area
			<tr>
			<td class="infoask">
				Maximum Canvas Area
			</td>
			<td class="infoenter">
				<input name="canvas_a" type="text" value="<?=$cfg['canvas_a']?>" size="40" class="txtinput" />

				<p class="subtext">
					This setting allows for large, panoramic canvases without affecting bandwidth.  Example: 1000 &times; 250 uses the same bandwidth as 500 &times 500, while allowing the max width and height to be 1000 pixels each.  However, a 1000 &times 1000 canvas would not be allowed.  Default is 250000 pixels.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>
			-->


			<!-- Preview Image-->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_canvasprev?>
			</td>
			<td class="infoenter" valign="top">
				<input name="preview_img" type="text" value="<?=$cfg['preview_img']?>" size="40" class="txtinput" />

				<p class="subtext">
					<?=$langop_cpmsg3?>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Preview Title -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_pviewtitle?>
			</td>
			<td class="infoenter" valign="top">
				<input name="preview_title" type="text" value="<?=$cfg['preview_title']?>" size="40" class="txtinput" />

				<p class="subtext">
					<?=$langop_titleprevwi?>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pr0n Image -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_pron?>
			</td>
			<td class="infoenter" valign="top">
				<input name="xxx_img" type="text" value="<?=$cfg['porn_img']?>" size="40" class="txtinput" />

				<p class="subtext">
					<?=$langop_prondesc?>
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Mailbox -->
		<h1 class="header">
			<?=$langop_word_display?> - <?=$langop_word_mailbox?> 
		</h1>

		<div class="infotable">
			<table class="infomain">

			<!-- Enable Mailbox -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_word_enable?> <?=$langop_word_mailbox?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="use_mailbox" class="multiline">
<? if ($cfg['use_mailbox'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Chat -->
		<h1 class="header">
			<?=$langop_install_dispchat?> 
		</h1>

		<div class="infotable">
			<table class="infomain">

			<!-- Enable Chat -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_enablechat?>
			</td>
			<td class="infoenter" valign="top">
				<select name="use_chat" class="multiline">
<? if ($cfg['use_chat'] == 'yes') { ?>
					<option value="no"><?=$langop_word_no?> (<?=$langop_word_recommended?>)</option>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
<? } else { ?>
					<option value="no" selected="selected"><?=$langop_word_no?> (<?=$langop_word_recommended?>)</option>
					<option value="yes"><?=$langop_word_yes?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_chatnote?>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Chat Total Lines -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_displinesmax?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="chat_max" type="text" value="<?=$cfg['chat_max']?>" size="8" class="txtinput" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Chat Lines Per Page -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_install_displines?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="chat_pages" type="text" value="<?=$cfg['chat_pages']?>" size="8" class="txtinput" />
			</td>
			</tr>

			</table>
		</div>
		<br />



		<!-- Compression Settings -->
		<h1 class="header">
			<?=$langop_compress_title?> 
		</h1>

		<div class="infotable">
			<p class="infonote">
<? if (!extension_loaded ('gd')) { ?>
				<?=$langop_err_nogdlib?><br />
				<br />
<? } ?>
				<?=$langop_thumbmodes?><br />
				<br />
				<?=$langop_thumbmodesexp?><br />
				<br />
				<?=$langop_thumbmodesexp2?>
			</p>

			<table class="infomain">
			<!-- Layout mode -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_defthumbmode?>
			</td>
			<td class="infoenter" valign="top">
				<select name="use_thumb" class="multiline">
					<option value="0"<? if ($cfg['use_thumb']==0) echo ' selected="selected"';?>><?=$langop_word_none?></option>
					<option value="1"<? if ($cfg['use_thumb']==1) echo ' selected="selected"';?>><?=$langop_word_layout?></option>
					<option value="2"<? if ($cfg['use_thumb']==2) echo ' selected="selected"';?>><?=$langop_word_defscale?></option>
					<option value="3"<? if ($cfg['use_thumb']==3) echo ' selected="selected"';?>><?=$langop_word_uniformity?></option>
				</select>

				<p class="subtext">
					<?=$langop_optiontip?>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Force Layout -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_forcedefthumb?>
			</td>
			<td class="infoenter" valign="top">
				<select name="force_thumb" class="multiline">
<? if ($cfg['force_thumb'] == 'yes') { ?>
					<option value="yes" selected="selected"><?=$langop_word_yes?></option>
					<option value="no"><?=$langop_word_no?></option>
<? } else { ?>
					<option value="yes"><?=$langop_word_yes?></option>
					<option value="no" selected="selected"><?=$langop_word_no?></option>
<? } ?>
				</select>

				<p class="subtext">
					<?=$langop_forcethumbdesc?>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Small Thumbnail Size -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_smallthumb?>
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_t" type="text" value="<?=$cfg['thumb_t']?>" size="8" class="txtinput" />

				<p class="subtext">
					<?=$langop_smallthumbdesc?>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Large Thumbnail Size -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_largethumb?>
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_r" type="text" value="<?=$cfg['thumb_r']?>" size="8" class="txtinput" />

				<p class="subtext">
					<?=$langop_largethumbdesc?>
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Thumbnail Bytes -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_thumbnailfilesize?> 
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_bytes" type="text" value="<?=$cfg['thumb_bytes']?>" size="10" class="txtinput" />
				<?=$langop_install_bytes?> 

				<p class="subtext">
					<?=$langop_thumbsizedesc?> 
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Thumbnail Rebuild -->
			<tr>
			<td class="infoask" valign="top">
				<?=$langop_rebuthumb?> 
			</td>
			<td class="infoenter" valign="top">
				<select name="rebuildThumb" class="multiline">
					<option value="0" selected="selected"><?=$langop_pgone?></option>
					<option value="1"><?=$langop_archipon?></option>
					<option value="2"><?=$langop_allthumb?></option>
				</select>

				<p class="subtext">
					<?=$langop_rebuthumbnote?> 
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Submit Changes -->
		<h1 class="header">
			<?=$langop_submitchange?>
		</h1>

		<div class="infotable">
			<p style="text-align: center">
				<input type="submit" name="Submit" value="<?=$langop_word_submit?>" class="submit" />
			</p>
		</div>
	</form>
</div>


<? include ('footer.php'); ?>