<?php
/*
Wacintaki Poteto Draw Script Copyright 2004-2009 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.4.2 - Last modified 5/2/2009

NOTE: this file is not officially part of OekakiPoteto 5.x.
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');


// Get custom cookie for draw settings
if (isset ($_COOKIE['drawset'])) {
	$drawset = @unserialize (w_gpc('drawset', 'raw'));
}
if (!isset ($drawset)) {
	$drawset = array('app'=>0, 'anim'=>0, 'close'=>1);
}


// Pictures folder locked?
if (!is_writable ($cfg['op_pics'])) {
	report_err($langop_picfolocked);
}

// OekakiBBS present?
$oeb_exists = false;
if (file_exists ('oekakibbs.jar')) {
	$oeb_exists = true;
}

// ChibiPaint present?
$chi_exists = false;
if (file_exists ('chibipaint.jar')) {
	$chi_exists = true;
}


// Check GET: draw info
if (isset ($_GET['Submit'])) {
	$app   = w_gpc('applet');
	$xsize = w_gpc('canvasx', 'i');
	$ysize = w_gpc('canvasy', 'i');

	$useapp = '';
	$datatype = 0;
	$app_params = '';

	switch ($app) {
		case 'paintbbs':
			$useapp = 'paintBBS.php';
			$drawset['app'] = 5;
			break;
		case 'notebbs':
			$useapp = 'noteBBS.php';
			$drawset['app'] = 4;
			break;
		case 'oekakibbs':
			$useapp = 'oekakiBBS.php';
			$datatype = 1;
			$drawset['app'] = 3;
			break;
		case 'shi':
			$useapp = 'shiBBS.php';
			$datatype = 2;
			$drawset['app'] = 0;
			break;
		case 'shipro':
			$useapp = 'shiBBS.php';
			$datatype = 3;
			$app_params = 'tools=pro&cursor=cursor&';
			$drawset['app'] = 1;
			break;
		case 'chibipaint':
			$useapp = 'chibipaint.php';
			$datatype = 4;
			$drawset['app'] = 2;
			break;
		default:
			all_done();
	}

	if ($xsize < $cfg['canvas_x']) $xsize == $cfg['min_x'];
	if ($ysize < $cfg['canvas_y']) $ysize == $cfg['min_y'];
	if ($xsize > $cfg['canvas_x']) $xsize == $cfg['canvas_x'];
	if ($ysize > $cfg['canvas_y']) $ysize == $cfg['canvas_y'];

	$extra_cgi = '';
	if (w_gpc('anim') == 'on') {
		$extra_cgi .= '&anim=1';
		$drawset['anim'] = 1;
	} else {
		$drawset['anim'] = 0;
	}
	if (w_gpc('noclose') == 'on') {
		$extra_cgi .= '&noclose=1';
		$drawset['close'] = 1;
	} else {
		$drawset['close'] = 0;
	}
	if ($datatype > 0) {
		$extra_cgi .= '&datatype='.$datatype;
	}

	// Set custom cookie for draw settings (always set before get
	if (w_gpc('saveset')) {
		w_set_cookie('drawset', serialize ($drawset));
	}

	all_done($useapp.'?'.$app_params.'xcord='.$xsize.'&ycord='.$ysize.$extra_cgi);
}





/* START HTML */
include ('header.php');


// Check for unfinished pictures
$result = mysql_query ("SELECT COUNT(PIC_ID) FROM {$OekakiPoteto_Prefix}oekakidta WHERE postlock='0' AND usrname='$OekakiU'");
$num_rows = (int) mysql_result ($result, 0);

$too_many = FALSE;
if (defined ('ALLOW_ADDITIONAL_WIPS')) {
	if ($num_rows > ALLOW_ADDITIONAL_WIPS) {
		$too_many = TRUE;
	}
} else {
	if ($num_rows > 0) {
		$too_many = TRUE;
	}
}

if ($too_many) {
	// Unfinished pictures interface
?>
<div id="contentmain">

	<!-- Unfinished -->
	<h1 class="header">
		<?=$langop_icomppic?>
	</h1>

	<div class="infotable" style="text-align: center">
		<p>
			<?=$langop_youhave?> <?= $num_rows; ?> <? if($user['language'] == 'english') { echo 'unfinished picture'; if ($num_rows > 1) echo 's';} else { echo $langop_icomppic;}?>.  <?=$langop_plzfinish?> <? if ($num_rows > 1) {echo 'them';} else {echo 'it';} ?> <?=$langop_beforenewpic?> 
		</p>

		<p>
			<a href="recover.php"><?=$langop_clickrecoverpic?></a>.
		</p>
	</div>
</div>


<?
	include ('footer.php');
	exit;

}


?>
<div id="contentmain">

<?
// Print WIP notice if there is at least one, but still under limit
if ($num_rows > 0) {
	// Unfinished pictures interface
?>
	<!-- Unfinished -->
	<h1 class="header">
		<?=$langop_word_reminder;?> 
	</h1>

	<div class="infotable" style="text-align: center">
		<p>
			<?=$langop_youhave?> <?= $num_rows; ?> <? if($user['language'] == 'english') { echo 'unfinished picture'; if ($num_rows > 1) echo 's';} else { echo $langop_icomppic;}?>.
		</p>

		<p>
			<a href="recover.php"><?=$langop_clickrecoverpic?></a>.
		</p>
	</div>
	<br />


<?
}


// Print draw interface
?>
	<!-- Draw -->
	<h1 class="header">
		<?=$langop_word_draw?> 
	</h1>

	<div class="infotable">
		<table cellpadding="0" cellspacing="0" border="0">
		<tr>
		<td style="vertical-align: top;">
			<form action="draw.php" method="get">
				<h4 style="margin-top: 0;"><?=$langop_word_applet;?>:</h4>
				<p class="subtext">
<? $ch = 'checked="checked" ';?>
					<input type="radio" name="applet" value="shi" <? if($drawset['app']==0) echo $ch;?>/>Shi-Painter<br />
					<input type="radio" name="applet" value="shipro" <? if($drawset['app']==1) echo $ch;?>/>Shi-Painter Pro<br />
<? if ($chi_exists) { ?>
					<input type="radio" name="applet" value="chibipaint" <? if($drawset['app']==2) echo $ch;?>/>Chibi Paint <?=$langop_draw_no_anim;?><br />
<? } ?>
<? if ($oeb_exists) { ?>
					<input type="radio" name="applet" value="oekakibbs" <? if($drawset['app']==3) echo $ch;?>/>OekakiBBS (<a href="faq.php#faq_4"><?=$langop_warnrfaq;?></a>)<br />
<? } ?>
					<input type="radio" name="applet" value="notebbs" <? if($drawset['app']==4) echo $ch;?>/>PaintBBS<?=$langop_withpalet;?><br />
					<input type="radio" name="applet" value="paintbbs" <? if($drawset['app']==5) echo $ch;?>/>PaintBBS<br />
				</p>

				<h4><?=$langop_word_canvas?> (<?=$langop_word_min?>:&nbsp;<?=$cfg['min_x']?>&times;<?=$cfg['min_x']?>, <?=$langop_word_max?>:&nbsp;<?=$cfg['canvas_x']?>&times;<?=$cfg['canvas_y']?>):</h4>
				<p class="subtext">
					<input id="previewWidth" class="txtinput" onblur="updatePreview(<?=$cfg['min_x']?>, <?=$cfg['min_y']?>, <?=$cfg['canvas_x']?>, <?=$cfg['canvas_y']?>);" name="canvasx" value="<?=$cfg['def_x']?>" size="4" />
					&times;
					<input id="previewHeight" class="txtinput" onblur="updatePreview(<?=$cfg['min_x']?>, <?=$cfg['min_y']?>, <?=$cfg['canvas_x']?>, <?=$cfg['canvas_y']?>);" name="canvasy" value="<?=$cfg['def_y']?>" size="4" />
				</p>

<? if ($flags['M']) { ?>
				<h4><input type="checkbox" name="anim" <? if($drawset['anim']==1) echo $ch;?>/> <?=$langop_draw_anims_layers?></h4>
				<p class="subtext">
					<?=$langop_draw_combine_layers;?> 
				</p>

<? } ?>
				<h4><input type="checkbox" name="noclose" <? if($drawset['close']==1) echo $ch;?>/> <?=$langop_draw_close_confirm;?></h4>
				<p class="subtext">
					<?=$langop_draw_help_loss_pics;?> 
				</p>

				<h4><input type="checkbox" name="saveset" <? if(w_gpc('drawset')) echo $ch;?>/> <?=$langop_draw_remember_settings;?></h4>

				<br />
				<p class="subtext">
					<input type="submit" name="Submit" value="Submit" class="submit" />
				</p>
			</form>
		</td>
<? if ($cfg['preview_img']) { ?>
		<td style="padding-left: 30pt; vertical-align: top;">
			<div style="text-align: center;">
				<img id="previewImage" src="<?=$cfg['res_path'].'/'.$cfg['preview_img']?>" width="<?=$cfg['def_x']?>" height="<?=$cfg['def_y']?>" alt="[Canvas Preview]" title="<?=$cfg['preview_title']?>" /><br />
				(<?=$langop_canvasprev?>)
			</div>
		</td>
<? } ?>
		</tr>
		</table>
	</div>
</div>


<? include ('footer.php'); ?>