<?php
/*
Wacintaki Poteto Avatar Editor Copyright 2004-2008 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.4.0 - Last modified 7/13/2008
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');


/*
	Custom config for correct avatar save path.

	It's necessary to use a local path to save avatars, but this does not work
	correctly with sub domains.  A bit of backtick trickery is required to make
	this work in such situations.

	Put a custom path here, or leave blank to use default.  It must be a local
	path to the main domain folder, so many backticks may be required, such as
	"../../domain/avatars".  Check the directory structure on your server
	before messing around with this!

	// Example = "./../main/avatars/"
*/
$my_main_avatar_path = ""; // Put path here.


// Config:
$max_width  = $cfg['avatar_x'];
$max_height = $cfg['avatar_y'];
$good_upload = FALSE;


if ($cfg['use_avatars'] != 'yes') {
	report_err($langop_avatardisable);
}
// Must have *active* account
if (!$flags['member']) {
	report_err($langop_loginerr);
}


// Admin editing someone else's avatar?
$username = w_gpc('username');
if (empty($username)) {
	$username = $OekakiU;
}
if ($username != $OekakiU && $flags['admin']) {
	// Admin edit other profile
	$result = mysql_query ("SELECT * FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");
	if ($result) {
		if (mysql_num_rows ($result)) {
			$current_user = mysql_fetch_array ($result);
		} else {
			report_err("Member '{$username}' could not be found.");
		}
	} else {
		// It's serious to have SQL bomb here
		w_log_sql('editavatar:'.__LINE__);
		report_err('Profile not retrievable!  Check the log.');
	}
} else {
	// Edit own profile
	$username = $OekakiU;
	$current_user = $user;
}


// Upload avatar
if ($_POST['action'] == 'do') {
	require ('paintsave.php');

	// Use default, or strip trailing slash of custom path
	if (!isset($my_main_avatar_path) || empty($my_main_avatar_path)) {
		$my_main_avatar_path = $cfg['avatar_folder'];
	} else {
		$my_main_avatar_path = preg_replace ('/\/+$/', '', $my_main_avatar_path);
	}

	$old_filename = $current_user['avatar'];
	$old_filepath = $my_main_avatar_path.'/'.$current_user['avatar'];

	if ($_POST['del']) {
		// Delete Avatar?
		if (!empty ($current_user['avatar']) && file_exists ($old_filepath)) {
			@unlink ($old_filepath);
		}

		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET avatar='' WHERE usrname='$username'");

		$current_user['avatar'] = '';
	} elseif (!empty ($_FILES['avatar']['tmp_name'])) {
		// If file OK, get it
		if ($_FILES['avatar']['error'] != 0 || empty ($_FILES['avatar']['tmp_name'])) {
			report_err($langop_err_fileupl, TRUE);
		}

		// Get file
		$buffer = file_get_contents ($_FILES['avatar']['tmp_name']);

		// Filetype
		$type = get_filetype($buffer);
		if ($type != 'png' && $type != 'jpg' && $type != 'gif') {
			report_err($langop_unsuppic, TRUE);
		}

		// Get filesize
		$max_size = $cfg['avatar_x'] * $cfg['avatar_y'] * 3;
		if (strlen ($buffer) > $max_size) {
			report_err(str_replace ('{s}', $max_size, $langop_filetoolar), TRUE);
		}

		// Image properties
		$imagesize = @getimagesize ($_FILES['avatar']['tmp_name']);
		if (!$imagesize) {
			report_err($langop_err_imagesize, TRUE);
		}
		if ($imagesize[0] > $max_width || $imagesize[1] > $max_height) {
			report_err($langop_err_imagelar." {$max_width} &times; {$max_height} ".$langop_word_pixels."!", TRUE);
		}

		// Set filename
		// For browser caching reasons, set a pseudo-random name
		$filename = md5 ($username + strval (rand ())).'.'.$type;
		$filepath = $my_main_avatar_path.'/'.$filename;

		// Remove old avatar (WinPHP cache safe)
		if ($old_filename != $filename) {
			@unlink ($old_filepath);
		}

		// Save new one
		file_unlock ($filepath);
		if ($fp = fopen ($filepath, 'wb')) {
			fwrite ($fp, $buffer, strlen ($buffer));
			fclose ($fp);
			w_group_readable($filepath);

			// Add to DB
			$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET avatar='$filename' WHERE usrname='$username'");

			$good_upload = TRUE;
		} else {
			report_err($langop_fileuprop, TRUE);
		}

		$current_user['avatar'] = $filename;
	}
}


/* START HTML */
send_html_headers();
?>
<head>
	<meta http-equiv="content-Type" content="text/html; charset=<?=$charset?>" />
	<meta http-equiv="content-Language" content="<?=$metatag_language?>" />

	<title><?=$cfg['op_title']?></title>

	<link rel="stylesheet" type="text/css" href="<?=$cssinclude?>" title="<?=$template_name?>" />
</head>

<body>


<div class="pheader">
	<?=$langop_avatarupl?>
</div>
<div class="pinfotable">
	<p style="text-align: center;">
<? if ($good_upload) { ?>
		<?=$langop_avatarupdate?>
<? } else { ?>
		<?=$langop_avatarform?><br />
		<?=$langop_notlarg?> <?=$max_width ?>&times;<?=$max_height ?> <?=$langop_word_pixels?>.<br />
<? if ($cfg['use_c_avatars'] != 'yes') { ?>
		<?=$langop_avatarshpi?>
<? } ?>
<? } ?>
	</p>
</div>
<br />

<div>
	<table class="pinfotable" style="width: 100%;">
<? if ($flags['admin'] && $OekakiU != $username) { ?>
	<tr>
	<td class="pinfoask" style="width: 40%;" valign="top">
		<?=$langop_word_username?>:
	</td>
	<td class="pinfoenter" valign="top">
		<?=w_html_chars($username);?> 
	</td>
	</tr>

	<tr><td colspan="2">&nbsp;</td></tr>

<? } ?>
	<tr>
	<td class="pinfoask" style="width: 40%;" valign="top">
		<?=$langop_word_avatars?>:
	</td>
	<td class="pinfoenter" valign="top">
<? if (!empty ($current_user['avatar'])) { ?>
		<img src="<?= $cfg['avatar_folder'].'/'.$current_user['avatar'];?>" alt="avatar" /><br />
<? } else {?>
		(<?=$langop_noavatar?>)
<? } ?>
	</td>
	</tr>

	<tr><td colspan="2">&nbsp;</td></tr>

	<tr>
	<td class="pinfoask" style="width: 40%;" valign="top">
		<?=$langop_chgavatar?>:
	</td>
	<td class="pinfoenter" valign="top">
		<form name="form1" method="post" action="<?=$_SERVER['PHP_SELF'];?>" enctype="multipart/form-data">
			<input name="action" type="hidden" value="do" />
			<input name="username" type="hidden" value="<?=w_html_chars($username);?>" />
			<input name="avatar" type="file" size="30" class="txtinput" /><br />
			<br />
<? if (!empty ($current_user['avatar'])) { ?>
			<input name="del" type="checkbox" /> <?=$langop_delavatar?><br />
			<br />
<? } ?>
			<input name="submit" type="submit" value="<?=$langop_word_submit?>" class="submit" />
		</form>
	</td>
	</tr>
	</table>
</div>

<p style="text-align: center;">
	<a onclick="window.close(); return false;" href="#"><?=$langop_common_window?></a>
</p>

</body>
</html>
<?

mysql_close ($dbconn);
exit();

?>