<?php
/*
OekakiPoteto 5.x ©Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Bastéa-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications ©Copyright 2004-2009 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.4.3 - Last modified 9/7/2009
*/


/*
NOTES:

	When setting/unsetting cookies, we need to use an IIS-safe redirect, as IIS will not set cookies if an HTML 'Location:' directive is specified.

	Cookies are sent as the HTTP GET method, and thus don't [aren't supposed to] work with POST.  If not using w_gpc, be sure to test POST before using coookies, or your input may be empty!

*/


// Load bootstrap
// Boot will handle cookies if POST is empty
if (isset ($_POST['OekakiU']) && isset ($_POST['OekakiPass'])) {
	// boot.php will clean this
	$OekakiU    = $_POST['OekakiU'];
	$OekakiPass = $_POST['OekakiPass'];
} else {
	// Let boot.php figure it out
}
$no_template = TRUE;
$no_online   = TRUE;
define ('BOOT', 1);
require ('boot.php');


// Input
// $pageno


// Censor test
$cfg['censoring'] = 0; // WIP


// Some quick sanity checks.
if (
	strlen (w_gpc('comment')  > 10000)
	|| strlen (w_gpc('name')  > 60)
	|| strlen (w_gpc('title') > 60)
) {
	report_err('Input too large!');
}


// Redirect with page number and other CGI
// This is sent as an HTTP header, so don't use HTML encoding
$pic_redirect = '';
if ($pageno) {
	// Always needs a pageno
	$pic_redirect = '?pageno='.$pageno;
	if ($sort) {
		$pic_redirect .= '&sort='.$sort;
	}
	if (!empty ($artist)) {
		$pic_redirect .= '&artist='.urlencode ($artist);
	}
	if (!empty ($a_match)) {
		$pic_redirect .= '&a_match='.urlencode ($a_match);
	}
}


// ==================================================================
// Functions specific to this file
//
function check_php_code($text) {
	global $dbconn, $flags;

	if ($flags['owner']) {
		return TRUE;
	}

	if (defined ('ENABLE_PHP_RESOURCE') && ENABLE_PHP_RESOURCE == 1) {
		if ($flags['sadmin']) {
			return TRUE;
		}
	}

	if (strpos ($text, '<?') !== FALSE) {
		report_err('PHP code has been disabled in the notice, banner, and rules.');
	}
	return TRUE;
}



// ==================================================================
// Process login
//

// Login (from header.php)
if ($action == 'login') {
	$username = w_gpc('username');
	$pass     = w_gpc('pass');
	$usrpass3 = crypt ($pass, $cfg['salt']);

	$result = mysql_query ("SELECT usrname, usrpass, usrflags FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");

	if ($result) {
		$row = mysql_fetch_array ($result);

		// Check if passwords are correct and that the user is a non-pending member
		if (($usrpass3 == $row['usrpass']) && !strstr ($row['usrflags'], 'P')) {
			// Create cookie (overwrites existing)
			w_set_cookie ('OekakiU', $row['usrname']);
			w_set_cookie ('OekakiPass', $usrpass3);

			// Set IP address
			$result = mysql_query ("UPDATE `{$OekakiPoteto_MemberPrefix}oekaki` SET `IP`='{$address}' WHERE `usrname`='$username'");

			// IIS-safe redirect
			all_done('index.php;in');
		} else {
			report_err($langop_functions_err13);
		}
	}
}

// Logoff (from header.php)
if ($mode == 'logoff') {
	// Kill all cookies
	w_unset_cookie ('OekakiU');
	w_unset_cookie ('OekakiPass');

	// Take user off online list
	$online = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakionline WHERE onlineusr='$OekakiU'");

	// IIS-safe redirect
	all_done('index.php;out');
}



// ==================================================================
// Begin functions.php
//

// Mass OPMail
if ($action == 'massmail') {
	$send_to = w_gpc('send_to');
	$body    = w_gpc('body');
	$subject = w_gpc('subject');

	if ($flags['owner']) {
		// To whom do we send the messages?
		$sql_where = "WHERE usrflags != 'P'";

		// If we narrow the mass mail to a certain group, we must also update the log
		if ($send_to != 'G') {
			if ($send_to == 'A') {
				$sql_where = "WHERE rank >= ".RANK_MOD;
			} elseif ($send_to == 'S') {
				$sql_where = "WHERE rank >= ".RANK_SADMIN;
			} else {
				$sql_where = "WHERE usrflags LIKE '%{$send_to}%'";
			}
			w_log(WLOG_MASS_MAIL, "flags({$send_to}): {$subject}");
		}

		if (!empty ($send_to) && !empty ($OekakiU)) {
			if (empty ($subject)) {
				report_err($langop_functions_err1);
			}
			$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_MemberPrefix}oekaki ".$sql_where);
			if ($result) {
				while ($row = mysql_fetch_array ($result)) {
					$result3 = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakimailbox SET sender='{$OekakiU}', reciever='".addslashes($row['usrname'])."', subject='{$subject}', body='{$body}', senddate=NOW()");
				}
			}
		}
		all_done('mailbox.php');
	} else {
		report_err($langop_functions_err2);
	}
}



// Lost Password Send
if ($action == 'pretrieve') {
	$username = w_gpc('username');

	$result = mysql_query ("SELECT usrpass, email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");
	$numrows = mysql_num_rows ($result);

	if ($numrows != 0) {
		$row = mysql_fetch_array ($result);

		$mail_subject = $cfg['op_title'].' '.$langop_precover_title;
		$mail = "{$langop_word_dear} {$username},\n\n{$langop_precover_p1} [{$address} / {$hostname}] {$langop_precover_p2} {$cfg['op_title']} @ {$cfg['op_url']}. {$langop_precover_p3}:\n\n{$cfg['op_url']}/chngpass.php?vcode=".urlencode($row['usrpass'])."&username=".urlencode($username)."\n\n{$langop_precover_p4}\n\n{$langop_precover_p5}";

		w_log(WLOG_PASS_RECOVER, 'sent to: '.$row['email'], $username);

		if (CUT_EMAIL < 2) {
			$mail_sent = w_mail ($row['email'], $mail_subject, $mail);
		}

		if (!$mail_sent) {
			report_err('Sorry, the BBS e-mailer isn\'t working. Ask an admin to reset your password.');
		}
		all_done();
	} else {
		report_err($langop_functions_err4);
	}
}



// Password Reset
if ($action == 'pass_reset') {
	$usrname2  = w_gpc('usrname2');
	$new_pass  = trim (w_gpc('new_pass'));
	$new_pass2 = trim (w_gpc('new_pass2'));

	if ($flags['owner']) {
		if (empty ($new_pass) || empty ($usrname2)) {
			report_err('New password is invalid');
		}
		if ($new_pass != $new_pass2) {
			report_err('Password verification failed. Make sure the new password is typed properly in both fields');
		}
		if ($bad = badChars(stripslashes ($new_pass))) {
			report_err('New password contains illegal characters: '.make_list($bad, ', ', '"'));
		}

		// I am the Crypt Keyper!
		$crypt_pass = crypt ($new_pass, $cfg['salt']);
		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrpass='$crypt_pass' WHERE usrname='$usrname2'");

		if (!$result) {
			report_err('New password could not be set due to a database error. Try again');
		}

		w_log(WLOG_PASS_RESET, 'reset by: owner', $usrname2);
	} else {
		report_err('You do not have the credentials to access the password reset.');
	}

	all_done();
}



// Lost Password Change
if ($action == 'pchange') {
	$username = w_gpc('username');
	$vcode    = w_gpc('vcode');
	$newpass  = w_gpc('newpass');
	$retype   = w_gpc('retype');

	$result = mysql_query ("SELECT * FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");
	$numrows = mysql_num_rows ($result);

	if ($numrows != 0) {
		$row = mysql_fetch_array ($result);

		// Compare the existing password against the database
		if ($row['usrpass'] == $vcode) {
			// Compare the new password with the old
			if ($newpass == $retype) {
				if ($bad = badChars(stripslashes ($newpass))) {
					report_err('New password contains illegal characters: '.make_list($bad, ', ', '"'));
				}

				// Change the password
				$newpass = crypt ($newpass, $cfg['salt']);
				$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrpass='$newpass' WHERE usrname='$username'");

				if (!empty($OekakiU)) {
					// Logout
					w_unset_cookie ('OekakiU');
					w_unset_cookie ('OekakiPass');

					// Take user off online list
					$online = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakionline WHERE onlineusr='$OekakiU'");
				}

				w_log(WLOG_PASS_RESET, 'reset by: member', $username);

				// IIS-safe redirect
				all_done('index.php;out');
			} else {
				report_err($langop_functions_err5);
			}
		} else {
			report_err($langop_functions_err6);
		}
	} else {
		report_err($langop_functions_err7);
	}
}



// Mailbox Send
if ($action == 'mailsend') {
	$body     = w_gpc('body');
	$subject  = w_gpc('subject');
	$reciever = w_gpc('reciever');
	$MID      = w_gpc('MID', 'i');
	$reply    = w_gpc('reply', 'i');

	if (!empty ($OekakiU) && $flags['G']) {
		if (empty ($subject)) {
			report_err($langop_functions_err8);
		}

		$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$reciever}'");
		$numrows = mysql_num_rows ($result);

		if ($numrows != 0) {
			$row = mysql_fetch_array ($result);

			if ($reply) {
				$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekakimailbox SET mstatus={$mail_status['replied']} WHERE MID='{$MID}'");
			}
			$result = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakimailbox SET sender='{$OekakiU}', reciever='".addslashes ($row['usrname'])."', subject='{$subject}', body='{$body}', senddate=NOW()");

			all_done('mailbox.php');
		} else {
			report_err($langop_functions_err9);
		}
	} else {
		report_err($langop_functions_err10);
	}
}



// Mailbox Check Delete
if ($action == 'mail_check_delete') {
	if (isset ($_POST['MD'])) {
		foreach ($_POST['MD'] as $mid) {
			$del = (int) $mid;

			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakimailbox WHERE MID='{$del}' AND reciever='{$OekakiU}'");
		}
	}

	all_done('mailbox.php');
}



// Mailbox Delete
// (mailread.php)
if ($mode == 'maildelete') {
	$MID = w_gpc('MID', 'i');

	$result = mysql_query ("SELECT * FROM {$OekakiPoteto_MemberPrefix}oekakimailbox WHERE MID='{$MID}'");
	$row = mysql_fetch_array ($result);

	if ($row['reciever'] != $OekakiU) {
		report_err($langop_functions_err11);
	} else {
		$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakimailbox WHERE MID='{$MID}'");
		all_done('mailbox.php');
	}
}



// User delete
if ($action == 'deluser') {
	$usrname2  = w_gpc('usrname2', 'i'); // ID, not name!
	$confirm   = w_gpc('confirm', 'i');
	$no_reason = w_gpc('no_reason', 'i');
	$reason    = w_gpc('reason');

	if ($flags['sadmin']) {
		// Get e-mail of admin that deleted user
		$result2 = mysql_query ("SELECT email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$OekakiU'");
		$row = mysql_fetch_array ($result2);

		if ($confirm) {
			// Pic delete routine
			include ('paintsave.php');

			// Initiate delete
			$result = mysql_query ("SELECT ID, usrname, email, avatar FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE ID='{$usrname2}'");
			$row2 = mysql_fetch_array ($result);
			$row2['usrname'] = addslashes ($row2['usrname']);

			// Remove images
			$result = mysql_query ("SELECT PIC_ID FROM {$OekakiPoteto_Prefix}oekakidta WHERE usrname='{$row2['usrname']}'");
			while ($result && ($kill_me = mysql_fetch_array ($result))) {
				kill_picture_slot($kill_me['PIC_ID']);
			}

			// Remove avatar
			if (!empty ($row2['avatar'])) {
				@unlink ($cfg['avatar_folder'].'/'.$row2['avatar']);
			}

			// Goodbye
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakionline WHERE onlineusr='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakidta WHERE usrname='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE usrname='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakichat WHERE usrname='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakimailbox WHERE reciever='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE ID='{$row2['ID']}'");

			$reason ? $log_reason = 'yes': $log_reason = 'no';
			w_log(WLOG_DELETE_USER, 'reason sent: '.$log_reason, $row2['usrname']);

			// Send e-mail
			if (!$no_reason) {
				$mail_subject = $cfg['op_title'].' '.$langop_mandel_title;
				$mail = "{$langop_word_dear} {$row2['usrname']},\n\n{$langop_mandel_p1} {$cfg['op_title']} @ {$cfg['op_url']}. {$langop_mandel_p3}.\n\n{$cfg['op_title']} {$langop_word_admin}\n{$langop_mandel_p2}: {$OekakiU} ({$row['email']})\n{$langop_word_comments}: {$reason}";

				if (CUT_EMAIL < 2) {
					$mail_sent = w_mail ($row2['email'], $mail_subject, $mail);
				}

				if (!$mail_sent) {
					report_err('User deleted, but e-mailer isn\'t working. Notify user manually at <a href="mailto:'.$row2['email'].'">'.$row2['email'].'</a>.');
				}
			}
		}
	} else {
		report_err($langop_functions_err12);
	}
	all_done('delusr.php');
}



// Registration Verification
if ($mode == 'Verify') {
	$username = w_gpc('username');
	$vcode    = w_gpc('vcode');

	if ($cfg['approval'] == 'yes') {
		all_done();
	}

	// Get user info
	$result = mysql_query ("SELECT usrname, usrpass, usrflags, email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$username}'");
	$row = mysql_fetch_array ($result);

	if ($vcode == $row['usrpass'] && $row['usrflags'] == 'P') {
		$theflags = 'G';
		$permissions = $langop_type_guser."\n";
	
		if ($cfg['reg_draw'] == 'yes') {
			$theflags .= 'D';
			$permissions .= $langop_type_daccess."\n";
		}
		if ($cfg['reg_anim'] == 'yes') {
			$theflags .= 'M';
			$permissions .= $langop_type_aaccess."\n";
		}
		if ($cfg['reg_upload'] == 'yes') {
			$theflags .= 'U';
			$permissions .= $langop_type_uaccess."\n";
		}

		// Insert user with automatic acceptance and draw permissions
		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='{$theflags}' WHERE usrname='{$username}'");

		// Set cookies
		w_set_cookie ('OekakiU', $row['usrname']);
		w_set_cookie ('OekakiPass', $row['usrpass']);

		// Send e-mail
		$mail_subject = $cfg['op_title'].' '.$langop_autoreg_title;
		$mail = "{$langop_word_dear} {$row['usrname']},\n\n{$langop_autoreg_p1} {$cfg['op_title']} @ {$cfg['op_url']} {$langop_autoreg_p2}\n\n{$langop_autoreg_p3}:\n{$permissions}\n{$langop_autoreg_p4}\n\n{$cfg['op_title']} {$langop_word_admin}\n{$langop_autoreg_p5}";

		if (CUT_EMAIL < 1) {
			$mail_sent = w_mail ($row['email'], $mail_subject, $mail);
		}

		// IIS-safe redirect
		all_done('editprofile.php;in');
	} else {
		report_err($langop_functions_err14);
	}
}



// Registration (from register.php)
if ($action == 'register') {
	$username = w_gpc('username');
	$email    = w_gpc('email', 'email');
	$age      = decode_birthday($_POST['age_year'], $_POST['age_month'], $_POST['age_day']);
	$pass     = w_gpc('pass');
	$pass2    = w_gpc('pass2');
	$artURL   = w_gpc('artURL', 'url');
	$comment  = w_gpc('comments');

	if (empty ($username)) {
		all_done();
	}

	// Humanity test
	$x_test = w_gpc('x_test', 'i');
	$y_test = w_gpc('y_test', 'i');
	$e_test = w_gpc('e_test', 'i');
	if ($x_test + $y_test != $e_test || $e_test < 2) {
		w_exit('Humanity test failed.');
	}

	// Age verification?
	if ($cfg['op_adult'] == 'yes') {
		if (intval ($_POST['age_year']) < 1900 || intval ($_POST['age_year']) > 3000) {
			report_err('You must submit a valid age declaration (birth year).');
		}

		if (get_age($age) < MIN_AGE_ADULT) {
			report_err('Your age declaration could not be accepted.');
		}
	}

	// Prevent database from vomiting
	if ($bad = badChars(stripslashes ($username))) {
		report_err('Your user name contains illegal characters: '.make_list($bad, ', ', '"'));
	}
	$trimpass = trim ($pass);
	if (empty ($trimpass)) {
		report_err('You must enter a password');
	}
	if ($bad = badChars(stripslashes ($pass))) {
		report_err('Your password contains illegal characters: '.make_list($bad, ', ', '"'));
	}
	if ($cfg['require_art'] == 'yes') {
		if (empty ($artURL) || strlen ($artURL) < 8 || strstr ($artURL, '&lt;')) {
			// ('<' filters out IMG tags, etc)
			report_err('A valid URL is required to register on this BBS');
		}
	}
	if ($cfg['op_adult'] == 'yes' && empty ($age)) {
		report_err('You must declare your age to register on this BBS');
	}


	// Check if a member already exists
	$result = mysql_query ("SELECT usrname, email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");
	if ($result && mysql_num_rows ($result) > 0) {
		report_err('Member name already exists!');
	}

	// Check for duplicate e-mail
	//$result = mysql_query ("SELECT usrname, email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE email='$email'");
	//$row = mysql_fetch_array ($result);
	//if ($username == $row['usrname']) {
	//	report_err($langop_functions_err15);
	//}


	// Check if the passwords match
	$userpass1 = crypt ($pass, $cfg['salt']);
	if ($pass == $pass2) {
		// Add the user as pending
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekaki SET usrname='{$username}', email='{$email}', usrpass='{$userpass1}', age='{$age}', usrflags='P', comment='{$comment}', url='{$artURL}', joindate=NOW(), language='', templatesel='', avatar='', IP='{$address}', lastlogin=NOW()");

		$mail_sent = FALSE;
		if ($cfg['approval'] == 'no') {
			// Send an email for verification
			$mail_subject = $cfg['op_title'].' '.$langop_verreg_title;
			$mail = "{$langop_word_dear} {$username},\n\n{$langop_verreg_p1} {$cfg['op_title']} @ {$cfg['op_url']}. {$langop_verreg_p2}:\n\n{$cfg['op_url']}/functions.php?mode=Verify&vcode=".urlencode($userpass1)."&username=".urlencode($username)."\n\n{$langop_verreg_p3}\n\n{$langop_precover_p5}";

			if (CUT_EMAIL < 1) {
				$mail_sent = w_mail ($email, $mail_subject, $mail);
			}
		}

		if (!$mail_sent) {
			if ($cfg['approval'] == 'force') {
				// Auto-approve
				$theflags = 'G';
				if ($cfg['reg_draw'] == 'yes')
					$theflags .= 'D';
				if ($cfg['reg_anim'] == 'yes')
					$theflags .= 'M';
				if ($cfg['reg_upload'] == 'yes')
					$theflags .= 'U';

				$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='{$theflags}' WHERE usrname='{$username}'");

				// Registered automatically, so set cookies
				w_set_cookie ('OekakiU', $username);
				w_set_cookie ('OekakiPass', $userpass1);
				all_done('register.php?rules=2;regin');
			} else {
				// D'OH!
				report_err('Sorry, the BBS e-mailer isn\'t working. You\'ll have to wait for your application to be approved.');
			}
		}
	} else {
		report_err($langop_functions_err5);
	}

	all_done('register.php?rules=2');
}



// User Flag Modification (from modflags.php)
if ($action == 'modflags') {
	$usrname2 = w_gpc('usrname2');
	$new_rank = w_gpc('rank', 'i');

	if (!$flags['admin']) {
		report_err('You cannot access flag modification');
	}

	$result = mysql_query ("SELECT usrname, usrflags, usrpass, rank FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$usrname2'");
	$their_info = mysql_fetch_array ($result);


	// Hack check.  No error reporting.
	if (!$flags['owner']) {
		if ($new_rank >= $flags['rank']) {
			// Don't let admins upgrade own rank or overpromote
			$new_rank = $their_info['rank'];
		}
	} elseif ($OekakiU == $usrname2) {
		// Don't let owners lose own flags
		$new_rank = $their_info['rank'];
	}

	// Admin flag overrides
	if ($new_rank >= RANK_ADMIN) {
		$_POST['upload_user'] = 'U';
		$_POST['immunity'] = 'I';
	}

	$new_flags =
		$_POST['general'].
		$_POST['draw_user'].
		$_POST['anim_user'].
		$_POST['upload_user'].
		$_POST['adult_user'].
		$_POST['immunity'];


	// Update DB
	$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='$new_flags' WHERE usrname='$usrname2'");
	if (!$result) {
		report_err('Flags could not be set due to a database error. Try again');
	}

	if ($new_rank != $their_info['rank']) {
		$result2 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET rank='$new_rank' WHERE usrname='$usrname2'");
		if (!$result2) {
			report_err('Rank could not be set due to a database error. Try again');
		}
	}

	all_done('modflags.php');
}



// Add/Remove User (from addusr.php)
if ($action == 'adduser') {
	$usrname2      = w_gpc('usrname2');
	$draw_access   = w_gpc('reg_draw', 'i');
	$anim_access   = w_gpc('reg_anim', 'i');
	$upload_access = w_gpc('reg_upload', 'i');
	$accept        = w_gpc('accept', 'i');
	$reason        = w_gpc('reason');

	// Admins only
	if (!$flags['admin']) {
		report_err($langop_functions_err17);
	}

	// Get admin e-mail
	$result = mysql_query ("SELECT email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$OekakiU}'");
	$adminEmail = mysql_result ($result, 0);

	// Get user e-mail
	$result = mysql_query ("SELECT email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$usrname2}'");
	$their_email = mysql_result ($result, 0);

	if ($accept) {
		$theflags = 'G';
		$permissions = $langop_type_guser."\n";
	
		if ($draw_access == 1) {
			$theflags .= 'D';
			$permissions .= $langop_common_drawacc."\n";
		}
		if ($anim_access == 1) {
			$theflags .= 'M';
			$permissions .= $langop_common_aniacc."\n";
		}
		if ($upload_access == 1) {
			$theflags .= 'U';
			$permissions .= $langop_type_uaccess."\n";
		}

		$result2 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='{$theflags}' WHERE usrname='{$usrname2}'");

		w_log(WLOG_REG, 'accpted: flags('.$theflags.')', $usrname2);

		if (!empty ($their_email) && strpos ($their_email, '@')) {
			// Send e-mail
			$mail_subject = $cfg['op_title'].' '.$langop_autoreg_title;
			$mail = "{$langop_word_dear} {$usrname2},\n\n{$langop_autoreg_p1} {$cfg['op_title']} @ {$cfg['op_url']} {$langop_autoreg_p2}\n\n{$langop_autoreg_p3}:\n{$permissions}\n{$langop_autoreg_p4}\n\n{$cfg['op_title']} {$langop_word_admin}\n{$langop_common_approvby}: {$OekakiU} ({$adminEmail})\n{$langop_word_comments}: {$reason}";

			$mail_sent = FALSE;
			if (CUT_EMAIL < 1) {
				$mail_sent = w_mail ($their_email, $mail_subject, $mail);
			}

			if (!$mail_sent) {
				report_err('Note:  user was approved, but could not be e-mailed.');
			}

			all_done('addusr.php');
		} else {
			report_err('User was approved, but could not be e-mailed due to an invalid e-mail address.');
		}
	} else {
		$result2 = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$usrname2'");

		if (!empty ($their_email) && strpos ($their_email, '@')) {
			// Send e-mail
			$mail_subject = $cfg['op_title'].' '.$langop_autoreg_title;
			$mail = "{$langop_word_dear} {$usrname2},\n\n{$langop_rejmsg_p1} {$cfg['op_title']} @ {$cfg['op_url']}, {$langop_rejmsg_p2} {$cfg['op_title']} {$langop_rejmsg_p3}\n\n{$cfg['op_title']} {$langop_word_admin}\n {$langop_common_rejby}: {$OekakiU} ({$adminEmail})\n{$langop_word_comments}: {$reason}";

			$mail_sent = FALSE;
			if (CUT_EMAIL < 2) {
				$mail_sent = w_mail ($their_email, $mail_subject, $mail);
			}

			if (!$mail_sent) {
				report_err('User was rejected, but could not be e-mailed. Notify user manually at <a href="mailto:'.$their_email.'">'.$their_email.'</a>.');
			}

			all_done('addusr.php');
		} else {
			report_err('User was removed, but could not be e-mailed due to an invalid e-mail address.');
		}
	}
}



// Profile Edit
if ($action == 'editprofile') {
	$name       = w_gpc('name');
	$email      = w_gpc('email');
	$email_show = w_gpc('email_show', 'i');
	$age        = decode_birthday ($_POST['age_year'], $_POST['age_month'], $_POST['age_day']);
	$gender     = w_gpc('gender');
	$location   = w_gpc('location');
	$url        = w_gpc('url', 'url');
	$urltitle   = w_gpc('urltitle');
	$aim        = w_gpc('aim');
	$icq        = w_gpc('icq');
	$msn        = w_gpc('msn');
	$yahoo      = w_gpc('yahoo');
	$ircserver  = w_gpc('ircserver');
	$ircnick    = w_gpc('ircnick');
	$ircchan    = w_gpc('ircchan');
	$language2  = w_gpc('language2');
	$ctemplate  = w_gpc('ctemplate');
	$picview    = w_gpc('picview', 'i');
	$adult      = w_gpc('adult');
	$comment    = w_gpc('comment');
	$smilies_show = w_gpc('smilies_show', 'i');
	$no_viewer  = w_gpc('no_viewer', 'i');
	$username2  = w_gpc('username2');
	$oldpass    = w_gpc('oldpass');
	$passwd     = w_gpc('passwd');
	$passwdnew  = w_gpc('passwdnew');
	$thumbview  = w_gpc('thumbview', 'i');
	$screensize = w_gpc('screensize', 'i');

	// Admin change?
	$my_admin_flag = FALSE;
	if ($OekakiU != $username2 && $flags['admin']) {
		$my_admin_flag = TRUE;
	}
	// Edit which profile?
	$my_oekakiu = $OekakiU;
	if ($my_admin_flag) {
		$my_oekakiu = $username2; // Already slashed
	}


	// Test username
	$test = trim ($username2);
	if (empty ($test) || $OekakiU != $username2) {
		if (!$my_admin_flag) {
			// Profile mismatch
			all_done();
		}
	}

	// Age verification?
	if (!$flags['owner'] && $cfg['op_adult'] == 'yes') {
		if (intval ($_POST['age_year']) < 1900 || intval ($_POST['age_year']) > 3000) {
			report_err('You must submit a valid age declaration (birth year).');
		}

		if (get_age ($age) < MIN_AGE_ADULT) {
			report_err('Your age declaration could not be accepted.');
		}
	}

	// Add adult flag
	{
		$my_flags = array();

		$result = mysql_query ("SELECT usrflags, rank FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$my_oekakiu}'");
		if ($result && mysql_num_rows ($result)) {
			$row = mysql_fetch_array ($result);
			$my_flags = parse_flags($row['usrflags'], $row['rank']);
		}

		$trueflags = str_replace ('X', '', $my_flags['all']);
		if ($adult == 'X') {
			$trueflags .= 'X';
		}
	}

	// Censoring (prototype)
	if ($cfg['censoring'] == 1) {
		include_once ('censor.php');

		$comment = censor($comment);
	}

	// XSS filter (template and language)
	if ($bad = badChars($language2, 'file')) {
		$language2 = $cfg['language'];
	}
	if ($bad = badChars($ctemplate, 'file')) {
		$ctemplate = $cfg['template'];
	}

	// Add info to database
	$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET name='{$name}', url='{$url}', comment='{$comment}', email='{$email}', email_show={$email_show}, aim='{$aim}', icq='{$icq}', urltitle='{$urltitle}', MSN='{$msn}', yahoo='{$yahoo}', IRCserver='{$ircserver}', IRCnick='{$ircnick}', usrflags='{$trueflags}', location='{$location}', templatesel='{$ctemplate}', IRCchan='{$ircchan}', age='{$age}', gender='{$gender}', smilies_show={$smilies_show}, no_viewer={$no_viewer}, picview='{$picview}', thumbview='{$thumbview}', screensize='{$screensize}', language='{$language2}' WHERE usrname='{$my_oekakiu}'");

	// Update log.  Use $username2, as it is not slashed
	if ($my_admin_flag) {
		w_log(WLOG_EDIT_PROFILE, 'profile: updated', $username2);
	}

	// Update passwords (do this last!)
	if (!empty ($passwd) && !empty($passwdnew)) {
		$trim_passwd = trim ($passwd);
		$oldpass2 = crypt ($oldpass, $cfg['salt']);
		if (!empty ($trim_passwd) && $oldpass2 == $OekakiPass) {
			if ($passwd == $passwdnew) {
				$passenc = crypt ($passwd, $cfg['salt']);
				$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrpass='{$passenc}' WHERE usrname='{$my_oekakiu}'");

				// Update log before $OekakiU is unset
				// Use $username2, as it is not slashed
				if ($my_admin_flag) {
					w_log(WLOG_PASS_RESET, 'reset by: admin', $OekakiU);
				} else {
					w_log(WLOG_PASS_RESET, 'reset by: member', $username2);
				}

				// Logout
				if (!$my_admin_flag) {
					w_unset_cookie ('OekakiU');
					w_unset_cookie ('OekakiPass');
				}
			} else {
				report_err('New passwords do not match. Please type them again.');
			}
		}
	}

	all_done();
}



// Edit Ban List
if ($action == 'banedit') {
	$ipban   = trim (w_gpc('ipban', 'raw'));
	$hostban = trim (w_gpc('hostban', 'raw'));

	if ($flags['admin']) {
		$fail = 0;
		$hostfail = '';
		$ipfail = '';

		// Test if hosts are disabled.  If so, ignore.
		if (isset ($_REQUEST['hostban'])) {
			if ($fp = @fopen ($cfg['res_path'].'/hosts.txt', 'w')) {
				fwrite ($fp, $hostban);
				fclose ($fp);
			} else {
				$fail++;
				$hostfail = 'hosts.txt';
			}
		}

		// IPs
		if ($fp2 = @fopen ($cfg['res_path'].'/ips.txt', 'w')) {
			fwrite ($fp2, $ipban);
			fclose ($fp2);
		} else {
			$fail++;
			$ipfail = 'ips.txt';
		}

		if ($fail == 1) {
			report_err('Could not write to '.$hostfail.$ipfail.' file');
		} elseif ($fail == 2) {
			report_err('Could not write to files: '.$hostfail.' and '.$ipfail);
		}

		w_log(WLOG_BAN, 'banlist: updated');
	}
	all_done();
}



// Edit notice and banner
if ($action == 'editnotice') {
	// NOTE: import as raw, so PHP/JS/other code isn't damaged.
	// Leave it to the oekaki owner to handle HTML encoding.
	$banneredit = trim (w_gpc('banneredit', 'raw'));
	$newsedit   = trim (w_gpc('newsedit', 'raw'));

	if ($flags['admin']) {
		if (!$flags['owner']) {
			check_php_code($newsedit);
			check_php_code($banneredit);
		}

		// Write banner
		$fp = @fopen ($cfg['res_path'].'/banner.php', 'w');
		if ($fp) {
			fwrite ($fp, $banneredit);
			fclose ($fp);
		}

		// Write notice
		$fp2 = @fopen ($cfg['res_path'].'/notice.php', 'w');
		if ($fp2) {
			fwrite ($fp2, $newsedit);
			fclose ($fp2);

			w_log(WLOG_NOTICE, 'banner/notice: updated');
		}
	}
	all_done();
}



// Edit rules
if ($action == 'editrules') {
	// NOTE: import as raw, so PHP/JS/other code isn't damaged.
	// Leave it to the oekaki owner to handle HTML encoding.
	$rulesedit = trim (w_gpc('rulesedit', 'raw'));

	if ($flags['admin']) {
		if (!$flags['owner']) {
			check_php_code($rulesedit);
		}

		// Write rules
		$fp = @fopen ($cfg['res_path'].'/rules.php', 'w');
		if ($fp) {
			if (!empty ($rulesedit)) {
				fwrite ($fp, $rulesedit);
			} else {
				fwrite ($fp, "<p>\n{$langop_defrulz}\n</p>\n");
			}
			fclose ($fp);

			w_log(WLOG_NOTICE, 'rules: updated');
		}
	}
	all_done('showrules.php');
}



// Upload picture
if ($action == 'upload') {
	$title         = w_gpc('title');
	$comment       = w_gpc('comment');
	$time_invested = w_gpc('edittime');
	$datatype      = w_gpc('dtype', 'i');
	$adult         = w_gpc('adult', 'i');

	if ( !($flags['mod'] || $flags['U']) ) {
		report_err('You do not have the credentials to upload pictures.');
	}

	require ('paintsave.php');

	// Seconds hack
	if (strstr (strtolower ($time_invested), 's')) {
		$time_invested = intval ($time_invested);
	} else {
		$time_invested = intval ($time_invested) * 60;
	}
	if ($time_invested < 1 || $time_invested > 1000000)
		$time_invested = 0;


	// Verify upload name
	if (!empty ($_POST['usrname']) && $flags['mod']) {
		$upload_name = w_gpc('usrname');
	} else {
		$upload_name = $OekakiU;
	}

	// Censoring (prototype)
	if ($cfg['censoring'] == 1) {
		include_once ('censor.php');

		$comment = censor($comment);
	}

	// Set comment
	if (w_gpc('uploadby', 'i') || !$flags['mod']) {
		$comment = trim ($comment);
		if (empty ($comment)) {
			$comment = '(Uploaded by [b]'.$OekakiU.'[/b])';
		} else {
			$comment .= "\n\n".'(Uploaded by [b]'.$OekakiU.'[/b])';
		}
	}


	// Size cap.  Just an anti-spammer cap for now
	if ($_FILES['picture']['size'] > $cfg['max_pic']) {
		report_err('Picture too large!  Max size is '.$cfg['max_pic'].' bytes.');
	}


	// Collect picture
	if ($_FILES['picture']['error'] > 0 || empty ($_FILES['picture']['tmp_name'])) {
		if ($_FILES['picture']['error'] == UPLOAD_ERR_NO_FILE) {
			report_err('No picture data was received. Try again.');
		}
		report_err('An error occured while uploading. Try again.');
	}
	$buffer = file_get_contents ($_FILES['picture']['tmp_name']);


	// Collect animation if it exists
	$have_animation = 0;
	if ($_FILES['animation']['tmp_name']) {
		if ($_FILES['animation']['error'] == 0) {
			$anim_ext = strtolower (substr ($_FILES['animation']['name'], -3));
			if (($anim_ext == 'oeb' || $anim_ext == 'pch' || $anim_ext == 'chi') && ($_FILES['animation']['size'] <= $cfg['max_anim'])) {
				$buffer2 = file_get_contents ($_FILES['animation']['tmp_name']);
				$have_animation = 1;
			} else {
				$have_animation = 0;
				$anim_fail = 1;
			}
		}
	}


	// Check filetype
	// We'll have to assume anim data is valid, since pch has no headers
	$type = get_filetype($buffer);

	if ($type == 'bmp') {
		report_err('Picture is a Microsoft BMP file, which is not supported.');
	} elseif ($type == 'jp2') {
		report_err('JPEG2000 is not yet supported, as no supported oekaki applets can read it.');
	} elseif ($type == 'psd') {
		report_err('Picture is a Photoshop file, which is not supported.');
	} elseif ($type == 'zip') {
		report_err('Archives of pictures (ZIP/JAR files) are not supported.');
	} elseif ($type != 'png' && $type != 'jpg' && $type != 'gif') {
		report_err('Picture is an unsupported filetype.');
	}


	// Pic checks out, so reserve a slot
	$resno = get_new_picnumber();
	if ($resno == 0) {
		report_err(__FILE__.': Cannot allocate new PIC_ID for upload.');
	}


	// Cleanup slots
	$result = clean_picture_slots();

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='{$upload_name}', postdate=NOW(), comment='$comment', hostname='{$hostname}', PIC_ID='{$resno}', IP='{$address}', title='{$title}', adult='{$adult}', datatype='{$datatype}', edittime='{$time_invested}', animation='{$have_animation}', postlock='1'");

		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		w_log_sql('upload: cannot save image '.$p_prefix.$resno.'.'.$type);
		report_err('Could not insert picture into database.');
	}

	// Insert OK.  Add member piccount
	$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=(piccount + 1) WHERE usrname='{$OekakiU}'");


	// Write file(s)
	// Filetype is automatic!
	if (!save_image ($buffer, $resno)) {
		w_log(WLOG_FAIL, 'upload: cannot save image '.$resno);
	}
	if ($have_animation) {
		if (!save_anim ($buffer2, $resno, $anim_ext)) {
			w_log(WLOG_FAIL, 'upload: cannot save animation '.$resno);
		}
	}

	all_done();
}



// First post normal pic
if ($action == 'res_msg') {
	$picno      = w_gpc('picno', 'i+');
	$name       = w_gpc('name'); // Guest
	$email      = w_gpc('email', 'email'); // Guest
	$url        = w_gpc('url', 'url'); // Guest
	$adult      = w_gpc('adult', 'i');
	$title      = w_gpc('title');
	$comment    = w_gpc('comment');
	$share      = w_gpc('share', 'i');
	$share_pass = trim (w_gpc('share_pass'));
	$trans_pass = trim (w_gpc('trans_pass'));
	$wip        = w_gpc('wip', 'i');

	// Must always have login and picno
	if (empty ($OekakiU) || empty ($picno)) {
		all_done();
	}

	// Censoring (prototype)
	if ($cfg['censoring'] == 1) {
		include_once ('censor.php');

		$comment = censor($comment);
	}

	$result = mysql_query ("SELECT usrname, password, postlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID=$picno");
	if (!$result) {
		report_err('Database error. Try using <a href="recover.php">picture recovery</a>.');
	}
	$old_pic_info = mysql_fetch_array ($result);

	// Check all passwords
	if ($OekakiU == $old_pic_info['usrname'] || $trans_pass == $old_pic_info['password']) {

		// Special case for public pictures.  Cannot edit other's public pictures
		if ($OekakiU != $old_pic_info['usrname'] && $old_pic_info['password'] == 'public') {
			report_err('Direct public retouch not allowed (possible bug!)');
		}

		// Check immunity flag for addition
		if ($cfg['draw_immune'] == 'yes' && !$flags['I']) {
			if ($OekakiU == $old_pic_info['usrname']) {
				// This needs to be as failsafe as possible
				$give_i = mysql_query ("SELECT usrflags FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$OekakiU}'");

				if ($give_i) {
					$temp_flags = mysql_result ($give_i, 0);
					str_replace ('I', '', $temp_flags);
					$temp_flags .= 'I';
					$give_i = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='{$temp_flags}' WHERE usrname='{$OekakiU}'");
				}
			}
		}

		//
		// Share code
		// Sharing based exclusively on format of password
		switch ($share) {
			case 2:
				$share_pass = 'public';
				break;
			case 1:
				// Limit password to 12 chars
				// Safe clip, just in case autoslashes is on
				$share_pass = stripslashes ($share_pass);
				$share_pass = addslashes (substr ($share_pass, 0, 12));
				break;
			case 0:
				$share_pass = '';
		}
		if ($cfg['public_retouch'] != 'yes')
			$share_pass = '';

		//
		// WIP code.
		// Should pic be posted?
		//
		$wip ? $lock_stat = 0 : $lock_stat = 1;

		//
		// Bump code
		//
		$bump_me = ' '; // Use spacer!
		if ($old_pic_info['postlock'] == 0) {
			// WIP pictures should always be bumped on edit/post
			$bump_me .= ', postdate=NOW()';
		}
		if ($cfg['self_bump'] == 'yes' && w_gpc('bump', 'i')) {
			// Self-bump
			$bump_me .= ', postdate=NOW()';
			w_log(WLOG_BUMP, 'retouch: '.$picno);
		}

		//
		// Update DB
		$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET comment='$comment', hostname='$hostname', IP='$address', title='{$title}', adult='$adult', postlock='{$lock_stat}', password='{$share_pass}'{$bump_me} WHERE PIC_ID='{$picno}'");

		// If not a safety save, inc pic count
		if ($lock_stat) {
			$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=(piccount + 1) WHERE usrname='$OekakiU'");
		}

		// Report safety save
		if ($wip) {
			all_done('comment.php?wipok=1');
		} else {
			all_done();
		}
	} else {
		report_err($langop_functions_err18);
	}
}



// Comment Post
if ($action == 'add') {
	$picno   = w_gpc('picno', 'i+');
	$pageno  = w_gpc('pageno', 'i');
	$comment = w_gpc('comment');
	$uts     = w_gpc('uts', 'i');
	$name  = w_gpc('name');
	$email = w_gpc('email', 'email');
	$url   = w_gpc('url', 'url');

	// Check locked post
	if (!$flags['mod']) {
		$result = mysql_query ("SELECT threadlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
		if ($result && mysql_num_rows($result) > 0) {
			if (mysql_result ($result, 0) == 1) {
				report_err('You cannot post a comment because the thread is locked');
			}
		} else {
			header('HTTP/1.0 404 Not Found');
			header('Status: 404 Not Found');
			w_exit('Cannot find picture #'.$picno);
		}
	}


	// Guest post
	if (empty ($OekakiU)) {
		if ($cfg['guest_post'] != 'yes')
			all_done();

		// Referral test
		$cur_time = time();
		if ($uts < $cur_time - 36000 || $uts > $cur_time + 3600) {
			// PHP needs HTTP header *and* status
			header('HTTP/1.0 404 Not Found');
			header('Status: 404 Not Found');
			w_exit();
		}

		// Humanity test
		if ($cfg['humanity_post'] != 'no') {
			if (isset ($_COOKIE['guestPass']) && isset ($_COOKIE['guestName'])
				&& $_COOKIE['guestPass'] == w_crypt ($_COOKIE['guestName']))
			{
				// Cookie passed, skip test
			} else {
				$x_test = w_gpc('x_test', 'i');
				$y_test = w_gpc('y_test', 'i');
				$e_test = w_gpc('e_test', 'i');
				if ($x_test + $y_test != $e_test || $e_test < 2) {
					w_exit('Humanity test failed.');
				}
			}
		}

		// Run lame anti-spam test
		$comment2 = strtolower ($comment);
		if (strpos ($comment2, '&lt;a href=') !== FALSE) {
			header ('Content-Type: text/plain');
			w_exit('HTML links unsupported.  Use NiftyToo/BBCode instead.');
		}

		// Count number of links (default is 2)
		$max_guest_links = 2;
		if (defined ('MAX_GUEST_LINKS')) {
			$max_guest_links = MAX_GUEST_LINKS;
		}
		if ($max_guest_links < 1) {
			header ('Content-Type: text/plain');
			w_exit('Links disabled for guests.');
		}
		$count = count (explode("://", $comment2));
		if ($count >= $max_guest_links * 2) {
			header ('Content-Type: text/plain');
			w_exit('Guests may only post '.$max_guest_links.' links per comment on this board.');
		}
		$count = count (explode("[url", $comment2));
		if ($count >= $max_guest_links * 2) {
			header ('Content-Type: text/plain');
			w_exit('Guests may only post '.$max_guest_links.' links per comment on this board.');
		}
	}


	// Censoring (prototype)
	if ($cfg['censoring'] == 1) {
		include_once ('censor.php');

		$comment = censor($comment);
	}

	// Add comment
	if (!empty ($OekakiU)) {
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakicmt SET usrname='{$OekakiU}', comment='{$comment}', hostname='{$hostname}', postdate=NOW(), PIC_ID='{$picno}', IP='{$address}'");
		$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET lastcmt=NOW() WHERE PIC_ID='{$picno}'");
		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET commcount=(commcount + 1) WHERE usrname='{$OekakiU}'");
	} else {
		// Validate $name (used only for guest posts)
		if (empty ($name)) {
			all_done('index.php'.$pic_redirect.'#pic'.$picno);
		}
		if ($bad = badChars(stripslashes ($name))) {
			report_err('Do not use the following characters in your name: '.make_list($bad, ', ', '"'));
		}

		// Validate URL
		if (strlen ($url) < 8) {
			$url = '';
		}

		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakicmt SET usrname='Guest', postname='{$name}', comment='{$comment}', hostname='{$hostname}', email='{$email}', url='{$url}', postdate=NOW(), PIC_ID='{$picno}', IP='{$address}'");

		$human = w_crypt ($name);
		w_set_cookie ('guestName',  $name);
		w_set_cookie ('guestEmail', $email);
		w_set_cookie ('guestURL',   $url);
		w_set_cookie ('guestPass',  $human);

		$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET lastcmt=NOW() WHERE PIC_ID='$picno'");
	}

	all_done('index.php'.$pic_redirect.'#pic'.$picno);
}



// Delete Comment
if ($mode == 'udelcmt' || $mode == 'delcmt') {
	// Note: don't bother with commcount.  It can't be kept accurate.
	$cmtno = w_gpc('cmtno', 'i+');
	$page  = w_gpc('page', 'i+');
	$post  = w_gpc('post', 'i+');

	// Get poster
	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakicmt WHERE ID_3='{$cmtno}'");
	if ($result) {
		$name = mysql_result ($result, 0);

		w_log(WLOG_DELETE, 'delete comment: '.$cmtno, $name);

		$extra = 'index.php';
		// Set redirect
		if ($page) {
			$extra .= "?pageno={$page}";
		}
		if ($post) {
			$extra .= '#pic'.$post;
		}

		// Admin only
		if ($name != $OekakiU) {
			if ($flags['mod']) {
				$result4 = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE ID_3='{$cmtno}'");
				all_done($extra);
			} else {
				report_err($langop_functions_err19);
			}
		}

		// User
		if (!empty ($OekakiU)) {
			$result4 = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE ID_3='{$cmtno}'");
			all_done($extra);
		}
	}
}



// User Pic Delete
if ($action == 'del') {
	$picno  = w_gpc('picno', 'i+');
	$return = w_gpc('return');
	$a_match = w_gpc('a_match');

	if ($return == 'a_match') {
		$returnpage = 'index.php?a_match='.urlencode ($a_match);
	} elseif ($return == 'recover') {
		$returnpage = 'recover.php';
	} else {
		$returnpage = 'index.php';
	}

	$result = mysql_query ("SELECT usrname, postlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
	$row = mysql_fetch_array ($result);

	if ($row['usrname'] == $OekakiU || $flags['admin']) {
		include ('paintsave.php');

		kill_picture_slot($picno);

		// Reduce user piccount if not a WIP
		if ($row['postlock'] > 0) {
			$result4 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=(piccount - 1) WHERE usrname='".addslashes($row['usrname'])."'");
		}

		w_log(WLOG_DELETE, 'picture: '.$picno, $row['usrname']);

		all_done($returnpage);
	} else {
		report_err($langop_functions_err20);
	}
}



// Admin Picture Delete (from delconf.php)
if ($action == 'dela') {
	$picno  = w_gpc('picno', 'i+');
	$reason = w_gpc('reason');
	$return = w_gpc('return');
	$givereason = w_gpc('givereason', 'i');

	if ($flags['admin']) {
		include ('paintsave.php');

		$result2 = mysql_query ("SELECT usrname, ptype, postlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
		$row = mysql_fetch_array ($result2);

		// Send reason?
		if ($givereason) {
			if (empty ($reason)) {
				$reason = '(No reason specified)';
			}
			$reason2 = "{$langop_word_hello},\n\n{$langop_functions_yourpic} (".($cfg['op_url'].'/'.$p_pic.$picno.'.'.$row['ptype']).") {$langop_picdel_p1} {$OekakiU} {$langop_picdel_p2}:\n\n{$reason}\n\n{$langop_picdel_p3}";

			$result = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakimailbox SET sender='{$OekakiU}', reciever='{$row['usrname']}', subject='{$langop_picdel_title}', body='{$reason2}', senddate=NOW()");
		}

		kill_picture_slot($picno);

		// Reduce user piccount if not a WIP
		if ($row['postlock'] > 0) {
			$result4 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=(piccount - 1) WHERE usrname='".addslashes($row['usrname'])."'");
		}

		w_log(WLOG_DELETE, 'picture: '.$picno, $row['usrname']);
	}

	if ($return == 'delpics')
		all_done('delpics.php');

	all_done();
}



// Recover Pic Delete
if ($action == 'delr') {
	$picno = w_gpc('picno', 'i+');

	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
	if ($result) {
		$usrname = mysql_result ($result, 0);

		if ($flags['admin'] || $OekakiU == $usrname) {
			require ('paintsave.php');
			kill_picture_slot($picno);

			// Note: do not reduce piccount for WIP

			// Log if admin edit
			if ($flags['admin'] && $OekakiU != $usrname) {
				w_log(WLOG_DELETE, 'wip: '.$picno, $usrname);
			}

			all_done('recover.php');
		} else {
			report_err('Only an admin may delete this picture.');
		}
	}
	all_done();
}



// Edit Comment
if ($action == 'editcomment') {
	$comment2 = w_gpc('comment2');
	$idno     = w_gpc('idno', 'i');
	$editon   = w_gpc('editon', 'i');

	// Censoring (prototype)
	if ($cfg['censoring'] == 1) {
		include_once ('censor.php');

		$comment2 = censor($comment2);
	}

	// Comment owner
	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakicmt WHERE ID_3='$idno'");
	if ($result) {
		$usrname = mysql_result ($result, 0);

		if ($usrname != $OekakiU) {
			if ($flags['mod']) {
				if (!$flags['admin'] || ($flags['admin'] && $editon)) {
					$comment2 .= "\n\n(Edited by [b]{$OekakiU}[/b] on ".date($datef['admin_edit']).')';
				}

				// Log mod edits
				w_log(WLOG_EDIT_COMM, 'comment: '.$idno, $usrname);
			} else {
				report_err($langop_functions_err21);
			}
		} elseif ($editon) {
			$comment2 .= "\n\n({$langop_common_editedon} ".date($datef['admin_edit']).')';
		}
		$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakicmt SET comment='{$comment2}' WHERE ID_3='{$idno}'");
		all_done();
	}
}



// Edit Main Picture Comment
if ($action == 'picedit') {
	$title2    = w_gpc('title2');
	$comment2  = w_gpc('comment2');
	$adult     = w_gpc('adult', 'i');
	$picno     = w_gpc('picno', 'i+');
	$adminedit = w_gpc('adminedit');
	$password  = trim (w_gpc('password'));
	$editon    = w_gpc('editon', 'i');

	if (!empty ($password)) {
		// Limit password to 12 chars
		// Safe clip, just in case autoslashes is on
		$password = stripslashes ($password);
		$password = addslashes (substr ($password, 0, 12));
	}

	// Censoring (prototype)
	if ($cfg['censoring'] == 1) {
		include_once ('censor.php');

		$comment2 = censor($comment2);
	}

	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID=$picno");
	if ($result) {
		$usrname = mysql_result ($result, 0);

		if ($usrname != $OekakiU) {
			if ($flags['mod']) {
				if (!$flags['admin'] || ($flags['admin'] && $editon)) {
					$comment2 .= "\n\n(Edited by [b]{$OekakiU}[/b] on ".date($datef['admin_edit']).')';
				}

				// Log mod edits
				w_log(WLOG_EDIT_PIC, 'picture: '.$picno, $usrname);
			} else {
				report_err($langop_functions_err21);
			}
		} elseif ($editon) {
			$comment2 .= "\n\n({$langop_common_editedon} ".date($datef['admin_edit']).')';
		}
		$result3 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET title='{$title2}', comment='{$comment2}', adult='{$adult}', postlock=1, password='{$password}' WHERE PIC_ID={$picno}");
	}

	all_done();
}



// Archive picture
if ($mode == 'archive') {
	$picid = w_gpc('picid', 'i');

	if ($flags['admin']) {
		// Get archive flag
		$result = mysql_query ("SELECT archive, usrname FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID=$picid");

		if ($result) {
			$row = mysql_fetch_array ($result);

			// Toggle archive status
			$archive = (int) $row['archive'];
			$archive ? $archive = 0 : $archive = 1;

			$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET archive=$archive WHERE PIC_ID=$picid");

			// Reversed already!
			$archive ? $a_status = 'archive' : $a_status = 'unarchive';
			w_log(WLOG_ARCHIVE, $a_status.': '.$picid, $row['usrname']);
		}

		all_done('index.php'.$pic_redirect.'#pic'.$picid);
	} else {
		report_err($langop_functions_err3);
	}
}



// Lock thread
if ($mode == 'lock' || $mode == 'unlock') {
	$picno = w_gpc('picno', 'i+');

	if ($flags['mod']) {
		$result = mysql_query ("SELECT threadlock, usrname FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");

		if ($result) {
			$row = mysql_fetch_array ($result);

			// Toggle lock status
			$lock = (int) $row['threadlock'];
			$lock ? $lock = 0 : $lock = 1;

			$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET threadlock='$lock' WHERE PIC_ID='$picno'");

			// Reversed already!
			$lock ? $l_status = 'lock' : $l_status = 'unlock';
			w_log(WLOG_LOCK_THREAD, $l_status.': '.$picno, $row['usrname']);
		}

		all_done('index.php'.$pic_redirect.'#pic'.$picno);
	} else {
		report_err('You must be a moderator to lock or unlock threads.');
	}
}



// Block adult thread
if ($mode == 'block' || $mode == 'unblock') {
	$picno = w_gpc('picno', 'i+');

	// Get pic info
	$result = mysql_query ("SELECT usrname, adult FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
	$pic = mysql_fetch_array ($result);

	if ($flags['mod'] || $pic['usrname'] == $OekakiU) {
		// Toggle adult status
		$block = (int) $pic['adult'];
		$block ? $block = 0 : $block = 1;

		$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET adult='$block' WHERE PIC_ID='$picno'");

		// It may be policy to adult pictures, so log all events
		// Reversed already!
		$block ? $b_status = 'unadult' : $b_status = 'adult';
		w_log(WLOG_ADULT, $b_status.': '.$picno, $pic['usrname']);

		all_done('index.php'.$pic_redirect.'#pic'.$picno);
	} else {
		report_err('You must be a moderator to mark pictures other than yours as adult.');
	}
}



// WIP picture
if ($mode == 'wip_pic') {
	$picno  = w_gpc('picno', 'i+');

	if ($flags['mod']) {
		$result = mysql_query ("SELECT usrname, postlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");

		if ($result) {
			$pic_info = mysql_fetch_array ($result);

			// Toggle WIP status, and bump date
			intval ($pic_info['postlock']) ? $wip = 0 : $wip = 1;
			$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET postlock='$wip', postdate=NOW() WHERE PIC_ID='$picno'");

			// Decrease piccount
			$result2 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=(piccount-1) WHERE usrname='{$pic_info['usrname']}'");

			// Send mailbox message
			$subject = 'Safety save';
			$message = "One of your pictures has been turned into a safety save by [b]{$OekakiU}[/b].  To finish it, go to the draw screen.  It must be finished within {$cfg['safety_storetime']} days.";
			$result3 = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakimailbox SET sender='$OekakiU', reciever='{$pic_info['usrname']}', subject='$subject', body='$message', senddate=NOW()");

			w_log(WLOG_ADMIN_WIP, 'picture: '.$picno, $pic_info['usrname']);
		}

		all_done('index.php'.$pic_redirect.'#pic'.$picno);
	} else {
		report_err('Only moderators may change safety save status.');
	}
}



// Picture Bump
if ($mode == 'bump') {
	$resno = w_gpc('resno', 'i+');

	include ('paintsave.php');

	if ($flags['mod']) {
		$status = bump_post($resno);
	}

	// Don't log here.  bump_post() does that.

	all_done();
}



/* Force Thumbnail
	$GET_['resno'] = slot
	$GET_['type'] = type (PNG, JPEG)
*/
if ($mode == 'make_thumb') {
	$picno = w_gpc('picno', 'i+');

	require ('paintsave.php');

	// Hack for NineChime
	$thumb_type = 'jpg';
	if (w_gpc('type') == 'png')
		$thumb_type = 'png';

	if ($flags['mod']) {
		// Get status.
		$result3 = mysql_query ("SELECT usethumb, ptype, ttype, rtype FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
		$status = mysql_fetch_array ($result3);

		// Purge old
		if (!empty ($status['rtype'])) {
			$result3 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET usethumb=0, rtype='' WHERE PIC_ID='$picno'");
			file_unlock ($r_pic.$picno.'.'.$status['rtype']);
		}
		if (!empty ($status['ttype'])) {
			$result3 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET ttype='' WHERE PIC_ID='$picno'");
			file_unlock ($t_pic.$picno.'.'.$status['ttype']);
		}

		// If "R" thumbnails didn't exist, make them
		if (empty ($status['rtype'])) {
			save_thumbnail($picno, $status['ptype'], TRUE, $thumb_type);
		}

		all_done('index.php'.$pic_redirect.'#pic'.$picno);
	} else {
		report_err('Only moderators may use this function.');
	}
}



/*
	Uncaught condition

	Most of the time, this is due to the server's anti-spam or content filters flagging the CGI data and flushing it completely.  Very annoying, because there is no POST data to log -- not even a mode/action.
*/
header ('Content-Type: text/plain');
w_exit('No mode!  Some security policies, censoring, filtering, or advertisements on shared servers may interfere with comments and other POST data.  Ask your admin for help.');

?>